gtkmm: Gtk::Widget Class Reference

gtkmm 3.4.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | Related Functions
Gtk::Widget Class Reference

Abstract Widget (Base class for all widgets) More...

Inheritance diagram for Gtk::Widget:
[legend]

List of all members.

## Public Member Functions
virtual | ~Widget ()
| Destroys the widget.
GtkWidget* | gobj ()
| Provides access to the underlying C GtkObject.
const GtkWidget* | gobj () const
| Provides access to the underlying C GtkObject.
void | show ()
| Flags a widget to be displayed.
void | show_now ()
| Shows a widget.
void | hide ()
| Reverses the effects of show(), causing the widget to be hidden (invisible to the user).
void | show_all ()
| Recursively shows a widget, and any child widgets (if the widget is a container).
void | queue_draw ()
| Equivalent to calling queue_draw_area() for the entire area of a widget.
void | queue_draw_area (int x, int y, int width, int height)
| Convenience function that calls queue_draw_region() on the region created from the given coordinates.
void | queue_draw_region (const ::Cairo::RefPtr< const ::Cairo::Region >& region)
| Invalidates the rectangular area of widget defined by region by calling gdk_window_invalidate_region() on the widget's window and all its child windows.
void | queue_resize ()
| This function is only for use in widget implementations.
void | size_allocate (const Allocation& allocation)
| This function is only used by Gtk::Container subclasses, to assign a size and position to their child widgets.
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout.
void | get_preferred_width (int& minimum_width, int& natural_width) const
| Retrieves a widget's initial minimum and natural width.
void | get_preferred_height_for_width (int width, int& minimum_height, int& natural_height) const
| Retrieves a widget's minimum and natural height if it would be given the specified width.
void | get_preferred_height (int& minimum_height, int& natural_height) const
| Retrieves a widget's initial minimum and natural height.
void | get_preferred_width_for_height (int height, int& minimum_width, int& natural_width) const
| Retrieves a widget's minimum and natural width if it would be given the specified height.
void | get_preferred_size (Requisition& minimum_size, Requisition& natural_size) const
| Retrieves the minimum and natural size of a widget, taking into account the widget's preference for height-for-width management.
void | add_accelerator (const Glib::ustring& accel_signal, const Glib::RefPtr< AccelGroup >& accel_group, guint accel_key, Gdk::ModifierType accel_mods, AccelFlags accel_flags)
| Installs an accelerator for this widget in accel_group that causes accel_signal to be emitted if the accelerator is activated.
bool | remove_accelerator (const Glib::RefPtr< AccelGroup >& accel_group, guint accel_key, Gdk::ModifierType accel_mods)
| Removes an accelerator from widget, previously installed with add_accelerator().
void | set_accel_path (const Glib::ustring& accel_path, const Glib::RefPtr< AccelGroup >& accel_group)
| Given an accelerator group, accel_group, and an accelerator path, accel_path, sets up an accelerator in accel_group so whenever the key binding that is defined for accel_path is pressed, widget will be activated.
bool | mnemonic_activate (bool group_cycling)
| Emits the Gtk::Widget::signal_mnemonic_activate() signal.
bool | event (GdkEvent*event)
| Rarely-used function.
int | send_expose (GdkEvent*event)
| Very rarely-used function.
bool | send_focus_change (GdkEvent*event)
| Sends the focus change event to widget.
bool | activate ()
| For widgets that can be "activated" (buttons, menu items, etc.) this function activates them.
void | reparent (Widget& new_parent)
| Moves a widget from one Gtk::Container to another, handling reference count issues to avoid destroying the widget.
bool | intersect (const Gdk::Rectangle& area) const
bool | intersect (const Gdk::Rectangle& area, Gdk::Rectangle& intersection) const
| Computes the intersection of a widget's area and area, storing the intersection in intersection, and returns `true` if there was an intersection.
::Cairo::RefPtr< ::Cairo::Region > | region_intersect (const ::Cairo::RefPtr< ::Cairo::Region >& region) const
| Computes the intersection of a widget's area and region, returning the intersection.
void | freeze_child_notify ()
| Stops emission of Gtk::Widget::signal_child_notify() signals on widget.
void | child_notify (const Glib::ustring& child_property)
| Emits a Gtk::Widget::signal_child_notify() signal for the child property child_property on widget.
void | thaw_child_notify ()
| Reverts the effect of a previous call to freeze_child_notify().
void | set_can_focus (bool can_focus=true)
| Specifies whether widget can own the input focus.
bool | get_can_focus () const
| Determines whether widget can own the input focus.
bool | has_focus () const
| Determines if the widget has the global input focus.
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel.
void | grab_focus ()
| Causes widget to have the keyboard focus for the Gtk::Window it's inside.
void | set_can_default (bool can_default=true)
| Specifies whether widget can be a default widget.
bool | get_can_default () const
| Determines whether widget can be a default widget.
bool | has_default () const
| Determines whether widget is the current default widget within its toplevel.
void | grab_default ()
| Causes widget to become the default widget.
void | set_receives_default (bool receives_default=true)
| Specifies whether widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
bool | get_receives_default () const
| Determines whether widget is alyways treated as default widget withing its toplevel when it has the focus, even if another widget is the default.
bool | has_grab () const
| Determines whether the widget is currently grabbing events, so it is the only widget receiving input events (keyboard and mouse).
bool | device_is_shadowed (const Glib::RefPtr< const Gdk::Device >& device)
| Returns `true` if device has been shadowed by a GTK+ device grab on another widget, so it would stop sending events to widget.
void | add_modal_grab ()
| Block events to everything else than this widget and its children.
void | remove_modal_grab ()
| Remove the modal grab of the widget in case it was previously grabbed.
void | set_name (const Glib::ustring& name)
| Widgets can be named, which allows you to refer to them from a CSS file.
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget.
void | set_state (StateType state)
| This function is for use in widget implementations.
StateType | get_state () const
| Returns the widget's state.
void | set_state_flags (StateFlags flags, bool clear=true)
| This function is for use in widget implementations.
void | unset_state_flags (StateFlags flags)
| This function is for use in widget implementations.
StateFlags | get_state_flags () const
| Returns the widget state as a flag set.
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of a widget.
bool | get_sensitive () const
| Returns the widget's sensitivity (in the sense of returning the value that has been set using set_sensitive()).
bool | is_sensitive () const
| Returns the widget's effective sensitivity, which means it is sensitive itself and also its parent widget is sensitive.
void | set_visible (bool visible=true)
| Sets the visibility state of widget.
bool | get_visible () const
| Determines whether the widget is visible.
bool | get_has_window () const
| Determines whether widget has a Gdk::Window of its own.
bool | get_is_toplevel () const
| Determines whether widget is a toplevel widget.
bool | get_is_drawable () const
| Determines whether widget can be drawn to.
bool | get_realized () const
| Determines whether widget is realized.
bool | get_mapped () const
| Whether the widget is mapped.
void | set_app_paintable (bool app_paintable=true)
| Sets whether the application intends to draw on the widget in an Gtk::Widget::signal_draw() handler.
bool | get_app_paintable () const
| Determines whether the application intends to draw on the widget in an Gtk::Widget::signal_draw() handler.
void | set_double_buffered (bool double_buffered=true)
| Widgets are double buffered by default; you can use this function to turn off the buffering.
bool | get_double_buffered () const
| Determines whether the widget is double buffered.
void | set_redraw_on_allocate (bool redraw_on_allocate=true)
| Sets whether the entire widget is queued for drawing when its size allocation changes.
void | set_child_visible (bool is_visible=true)
| Sets whether widget should be mapped along with its when its parent is mapped and widget has been shown with show().
bool | get_child_visible () const
| Gets the value set with set_child_visible().
Glib::RefPtr< Gdk::Window > | get_window ()
| Returns the widget's window if it is realized, `0` otherwise.
Glib::RefPtr< const Gdk::Window > | get_window () const
| Returns the widget's window if it is realized, `0` otherwise.
int | get_allocated_width () const
| Returns the width that has currently been allocated to widget.
int | get_allocated_height () const
| Returns the height that has currently been allocated to widget.
Allocation | get_allocation () const
| Retrieves the widget's location.
void | set_allocation (const Allocation& allocation)
| Sets the widget's allocation.
Container* | get_parent ()
| Returns the parent container of widget.
const Container* | get_parent () const
| Returns the parent container of widget.
Glib::RefPtr< Gdk::Window > | get_parent_window ()
| Gets widget's parent window.
Glib::RefPtr< const Gdk::Window > | get_parent_window () const
| Gets widget's parent window.
void | set_parent_window (const Glib::RefPtr< const Gdk::Window >& parent_window)
| Sets a non default parent window for widget.
bool | child_focus (DirectionType direction)
| This function is used by custom widget implementations; if you're writing an app, you'd use grab_focus() to move the focus to a particular widget, and Gtk::Container::set_focus_chain() to change the focus tab order.
bool | keynav_failed (DirectionType direction)
| This function should be called whenever keyboard navigation within a single widget hits a boundary.
void | error_bell ()
| Notifies the user about an input-related error on this widget.
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of a widget; that is, the widget's size request will be width by height.
void | get_size_request (int& width, int& height) const
| Gets the size request that was explicitly set for the widget using set_size_request().
void | set_events (Gdk::EventMask events)
| Sets the event mask (see Gdk::EventMask) for a widget.
void | add_events (Gdk::EventMask events)
| Adds the events in the bitfield events to the event mask for widget.
void | set_device_events (const Glib::RefPtr< const Gdk::Device >& device, Gdk::EventMask events)
| Sets the device event mask (see Gdk::EventMask) for a widget.
void | add_device_events (const Glib::RefPtr< const Gdk::Device >& device, Gdk::EventMask events)
| Adds the device events in the bitfield events to the event mask for widget.
void | set_device_enabled (const Glib::RefPtr< Gdk::Device >& device, bool enabled=true)
| Enables or disables a Gdk::Device to interact with widget and all its children.
bool | get_device_enabled (const Glib::RefPtr< const Gdk::Device >& device) const
| Returns whether device can interact with widget and its children.
Container* | get_toplevel ()
| This function returns the topmost widget in the container hierarchy widget is a part of.
const Container* | get_toplevel () const
| This function returns the topmost widget in the container hierarchy widget is a part of.
Widget* | get_ancestor (GType widget_type)
| Gets the first ancestor of widget with type widget_type.
const Widget* | get_ancestor (GType widget_type) const
| Gets the first ancestor of widget with type widget_type.
Glib::RefPtr< Gdk::Visual > | get_visual ()
| Gets the visual that will be used to render widget.
Glib::RefPtr< Gdk::Screen > | get_screen ()
| Get the Gdk::Screen from the toplevel window associated with this widget.
Glib::RefPtr< const Gdk::Screen > | get_screen () const
| Get the Gdk::Screen from the toplevel window associated with this widget.
bool | has_screen () const
| Checks whether there is a Gdk::Screen is associated with this widget.
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the Gdk::Display for the toplevel window associated with this widget.
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the Gdk::Display for the toplevel window associated with this widget.
Glib::RefPtr< Gdk::Window > | get_root_window ()
| Get the root window where this widget is located.
Glib::RefPtr< const Gdk::Window > | get_root_window () const
| Get the root window where this widget is located.
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings used for this widget.
Glib::RefPtr< Clipboard > | get_clipboard (const Glib::ustring& selection)
| Returns the clipboard object for the given selection to be used with widget.
Glib::RefPtr< const Clipboard > | get_clipboard (const Glib::ustring& selection) const
| Returns the clipboard object for the given selection to be used with widget.
bool | get_hexpand () const
| Gets whether the widget would like any available extra horizontal space.
void | set_hexpand (bool expand=true)
| Sets whether the widget would like any available extra horizontal space.
bool | get_hexpand_set () const
| Gets whether set_hexpand() has been used to explicitly set the expand flag on this widget.
void | set_hexpand_set (bool set=true)
| Sets whether the hexpand flag (see get_hexpand()) will be used.
bool | get_vexpand () const
| Gets whether the widget would like any available extra vertical space.
void | set_vexpand (bool expand=true)
| Sets whether the widget would like any available extra vertical space.
bool | get_vexpand_set () const
| Gets whether set_vexpand() has been used to explicitly set the expand flag on this widget.
void | set_vexpand_set (bool set=true)
| Sets whether the vexpand flag (see get_vexpand()) will be used.
void | queue_compute_expand ()
| Mark widget as needing to recompute its expand flags.
bool | compute_expand (Orientation orientation)
| Computes whether a container should give this widget extra space when possible.
bool | get_support_multidevice () const
| Returns `true` if widget is multiple pointer aware.
void | set_support_multidevice (bool support_multidevice=true)
| Enables or disables multiple pointer awareness.
Glib::RefPtr< Atk::Object > | get_accessible ()
| Returns the accessible object that describes the widget to an assistive technology.
Glib::RefPtr< const Atk::Object > | get_accessible () const
| Returns the accessible object that describes the widget to an assistive technology.
Align | get_halign () const
| Gets the value of the Gtk::Widget::property_halign() property.
void | set_halign (Align align)
| Sets the horizontal alignment of widget.
Align | get_valign () const
| Gets the value of the Gtk::Widget::property_valign() property.
void | set_valign (Align align)
| Sets the vertical alignment of widget.
int | get_margin_left () const
| Gets the value of the Gtk::Widget::property_margin_left() property.
void | set_margin_left (int margin)
| Sets the left margin of widget.
int | get_margin_right () const
| Gets the value of the Gtk::Widget::property_margin_right() property.
void | set_margin_right (int margin)
| Sets the right margin of widget.
int | get_margin_top () const
| Gets the value of the Gtk::Widget::property_margin_top() property.
void | set_margin_top (int margin)
| Sets the top margin of widget.
int | get_margin_bottom () const
| Gets the value of the Gtk::Widget::property_margin_bottom() property.
void | set_margin_bottom (int margin)
| Sets the bottom margin of widget.
Gdk::EventMask | get_events () const
| Returns the event mask for the widget (a bitfield containing flags from the Gdk::EventMask enumeration).
Gdk::EventMask | get_device_events (const Glib::RefPtr< const Gdk::Device >& device) const
| Returns the events mask for the widget corresponding to an specific device.
void | get_pointer (int& x, int& y) const
| Obtains the location of the mouse pointer in widget coordinates.
bool | is_ancestor (Widget& ancestor) const
| Determines whether widget is somewhere inside ancestor, possibly with intermediate containers.
bool | translate_coordinates (Widget& dest_widget, int src_x, int src_y, int& dest_x, int& dest_y)
| Translate coordinates relative to src_widget's allocation to coordinates relative to dest_widget's allocations.
void | override_color (const Gdk::RGBA& color, StateFlags state=(StateFlags) 0)
void | unset_color (StateFlags state=(StateFlags) 0)
void | override_background_color (const Gdk::RGBA& color, StateFlags state=(StateFlags) 0)
void | unset_background_color (StateFlags state=(StateFlags) 0)
void | override_font (const Pango::FontDescription& font_desc)
| Sets the font to use for a widget.
void | unset_font ()
void | override_symbolic_color (const Glib::ustring& name, const Gdk::RGBA& color)
| Sets a symbolic color for a widget.
void | unset_symbolic_color (const Glib::ustring& name)
void | override_cursor (const Gdk::RGBA& cursor, const Gdk::RGBA& secondary_cursor)
| Sets the cursor color to use in a widget, overriding the Gtk::Widget::property_cursor_color() and Gtk::Widget::property_secondary_cursor_color() style properties.
void | unset_cursor ()
void | reset_style ()
| Updates the style context of widget and all descendents by updating its widget path.
template<class PropertyType >
void | get_style_property (const Glib::ustring& the_property_name, PropertyType&value) const
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new Pango::Context with the appropriate font map, font description, and base direction for drawing text for this widget.
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a Pango::Context with the appropriate font map, font description, and base direction for this widget.
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring& text)
| Creates a new Pango::Layout with the appropriate font map, font description, and base direction for drawing text for this widget.
Glib::RefPtr< Gdk::Pixbuf > | render_icon_pixbuf (const StockID& stock_id, IconSize size)
| A convenience function that uses the theme engine and style settings for widget to look up stock_id and render it to a pixbuf.
void | set_composite_name (const Glib::ustring& name)
| Sets a widgets composite name.
void | unset_composite_name ()
Glib::ustring | get_composite_name () const
| Obtains the composite name of a widget.
void | set_direction (TextDirection dir)
| Sets the reading direction on a particular widget.
TextDirection | get_direction () const
| Gets the reading direction for a particular widget.
void | shape_combine_region (const ::Cairo::RefPtr< const ::Cairo::Region >& region)
| Sets a shape for this widget's GDK window.
void | input_shape_combine_region (const ::Cairo::RefPtr< const ::Cairo::Region >& region)
| Sets an input shape for this widget's GDK window.
WidgetPath | get_path () const
| Returns the Gtk::WidgetPath representing widget, if the widget is not connected to a toplevel widget, a partial path will be created.
std::vector< Widget* > | list_mnemonic_labels ()
| Returns a newly allocated list of the widgets, normally labels, for which this widget is the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()).
std::vector< const Widget* > | list_mnemonic_labels () const
| Returns a newly allocated list of the widgets, normally labels, for which this widget is the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()).
void | add_mnemonic_label (Widget& label)
| Adds a widget to the list of mnemonic labels for this widget.
void | remove_mnemonic_label (Widget& label)
| Removes a widget from the list of mnemonic labels for this widget.
void | drag_get_data (const Glib::RefPtr< Gdk::DragContext >& context, const Glib::ustring& target, guint32 time)
| Gets the data associated with a drag.
void | drag_highlight ()
| Draws a highlight around a widget.
void | drag_unhighlight ()
| Removes a highlight set by gtk_drag_highlight() from a widget.
void | drag_dest_set (DestDefaults flags=DestDefaults(0), Gdk::DragAction actions=Gdk::DragAction(0))
void | drag_dest_set (const std::vector< TargetEntry >& targets, DestDefaults flags=DEST_DEFAULT_ALL, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_dest_set_proxy (const Glib::RefPtr< Gdk::Window >& proxy_window, Gdk::DragProtocol protocol, bool use_coordinates)
| Sets this widget as a proxy for drops to another window.
void | drag_dest_unset ()
| Clears information about a drop destination set with gtk_drag_dest_set().
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext >& context, const Glib::RefPtr< TargetList >& target_list) const
| Looks for a match between context->targets and the dest_target_list, returning the first matching target, otherwise returning Gdk::NONE.
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext >& context) const
Glib::RefPtr< TargetList > | drag_dest_get_target_list ()
| Returns the list of targets this widget can accept from drag-and-drop.
Glib::RefPtr< const TargetList > | drag_dest_get_target_list () const
| Returns the list of targets this widget can accept from drag-and-drop.
void | drag_dest_set_target_list (const Glib::RefPtr< TargetList >& target_list)
| Sets the target types that this widget can accept from drag-and-drop.
void | drag_dest_add_text_targets ()
| Add the text targets supported by Gtk::Selection to the target list of the drag destination.
void | drag_dest_add_image_targets ()
| Add the image targets supported by Gtk::Selection to the target list of the drag destination.
void | drag_dest_add_uri_targets ()
| Add the URI targets supported by Gtk::Selection to the target list of the drag destination.
void | drag_source_set (const std::vector< TargetEntry >& targets, Gdk::ModifierType start_button_mask=Gdk::MODIFIER_MASK, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_source_unset ()
| Undoes the effects of set().
void | drag_source_set_icon (const Glib::RefPtr< Gdk::Pixbuf >& pixbuf)
| Sets the icon that will be used for drags from a particular widget from a Gdk::Pixbuf.
void | drag_source_set_icon (const StockID& stock_id)
| Sets the icon that will be used for drags from a particular source to a stock icon.
void | drag_source_set_icon (const Glib::ustring& icon_name)
| Sets the icon that will be used for drags from a particular source to a themed icon.
void | drag_source_add_text_targets ()
| Add the text targets supported by Gtk::Selection to the target list of the drag source.
void | drag_source_add_uri_targets ()
| Add the URI targets supported by Gtk::Selection to the target list of the drag source.
void | drag_source_add_image_targets ()
| Add the writable image targets supported by Gtk::Selection to the target list of the drag source.
Glib::RefPtr< Gdk::DragContext > | drag_begin (const Glib::RefPtr< TargetList >& targets, Gdk::DragAction actions, int button, GdkEvent*event)
| Initiates a drag on the source side.
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
| Checks to see if a mouse drag starting at ( start_x, start_y) and ending at ( current_x, current_y) has passed the GTK+ drag threshold, and thus should trigger the beginning of a drag-and-drop operation.
void | drag_set_as_icon (const Glib::RefPtr< Gdk::DragContext >& context, int hot_x, int hot_y)
void | queue_resize_no_redraw ()
| This function works like queue_resize(), except that the widget is not invalidated.
bool | get_no_show_all () const
| Returns the current value of the Gtk::Widget::property_no_show_all() property, which determines whether calls to show_all() will affect this widget.
void | set_no_show_all (bool no_show_all=true)
| Sets the Gtk::Widget::property_no_show_all() property, which determines whether calls to show_all() will affect this widget.
void | set_parent (Widget& parent)
| This function is useful only when implementing subclasses of Gtk::Container.
void | unparent ()
| This function is only for use in widget implementations.
void | map ()
| This function is only for use in widget implementations.
void | unmap ()
| This function is only for use in widget implementations.
void | draw_insertion_cursor (const ::Cairo::RefPtr< ::Cairo::Context >& cr, const Gdk::Rectangle& location, bool is_primary, TextDirection direction, bool draw_arrow=true)
void | set_tooltip_window (Window& widget)
| Replaces the default, usually yellow, window used for displaying tooltips with custom_window.
Window* | get_tooltip_window ()
| Returns the Gtk::Window of the current tooltip.
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display where the toplevel of widget is located.
void | set_tooltip_text (const Glib::ustring& text)
| Sets text as the contents of the tooltip.
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for widget.
void | set_tooltip_markup (const Glib::ustring& markup)
| Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language.
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for widget.
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the has-tooltip property on widget to has_tooltip.
bool | get_has_tooltip () const
| Returns the current value of the has-tooltip property.
int | get_width () const
int | get_height () const
bool | is_composited () const
| Whether widget can rely on having its alpha channel drawn correctly.
bool | in_destruction () const
| Returns whether the widget is currently being destroyed.
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the style context associated to widget.
Glib::RefPtr< Gtk::StyleContext > | get_style_context () const
| Returns the style context associated to widget.
Gdk::ModifierType | get_modifier_mask (Gdk::ModifierIntent intent)
| Returns the modifier mask the widget's windowing system backend uses for a particular purpose.
Glib::SignalProxy0< void > | signal_show ()
Glib::SignalProxy0< void > | signal_hide ()
Glib::SignalProxy0< void > | signal_map ()
| Emitted on mapping of a widget to the screen.
Glib::SignalProxy0< void > | signal_unmap ()
Glib::SignalProxy0< void > | signal_realize ()
| Emitted on realization of a widget.
Glib::SignalProxy0< void > | signal_unrealize ()
Glib::SignalProxy1< void, Allocation& > | signal_size_allocate ()
Glib::SignalProxy1< void, Gtk::StateType > | signal_state_changed ()
Glib::SignalProxy1< void, Gtk::StateFlags > | signal_state_flags_changed ()
Glib::SignalProxy1< void, Widget* > | signal_parent_changed ()
| Informs objects that their parent changed.
Glib::SignalProxy1< void, Widget* > | signal_hierarchy_changed ()
Glib::SignalProxy0< void > | signal_style_updated ()
Glib::SignalProxy1< void, TextDirection > | signal_direction_changed ()
Glib::SignalProxy1< void, bool > | signal_grab_notify ()
Glib::SignalProxy1< void, GParamSpec* > | signal_child_notify ()
Glib::SignalProxy1< bool, bool > | signal_mnemonic_activate ()
Glib::SignalProxy0< void > | signal_grab_focus ()
Glib::SignalProxy1< bool, DirectionType > | signal_focus ()
Glib::SignalProxy1< bool, GdkEvent* > | signal_event ()
Glib::SignalProxy1< void, GdkEvent* > | signal_event_after ()
Glib::SignalProxy1< bool, GdkEventButton* > | signal_button_press_event ()
| Event triggered by user pressing button.
Glib::SignalProxy1< bool, GdkEventButton* > | signal_button_release_event ()
| Event triggered by user releasing button.
Glib::SignalProxy1< bool, GdkEventScroll* > | signal_scroll_event ()
Glib::SignalProxy1< bool, GdkEventMotion* > | signal_motion_notify_event ()
| Event triggered by user moving pointer.
Glib::SignalProxy1< bool, GdkEventAny* > | signal_delete_event ()
Glib::SignalProxy1< bool, const ::Cairo::RefPtr < ::Cairo::Context >& > | signal_draw ()
Glib::SignalProxy1< bool, GdkEventKey* > | signal_key_press_event ()
| Event triggered by a key press will widget has focus.
Glib::SignalProxy1< bool, GdkEventKey* > | signal_key_release_event ()
| Event triggered by a key release will widget has focus.
Glib::SignalProxy1< bool, GdkEventCrossing* > | signal_enter_notify_event ()
| Event triggered by pointer entering widget area.
Glib::SignalProxy1< bool, GdkEventCrossing* > | signal_leave_notify_event ()
| Event triggered by pointer leaving widget area.
Glib::SignalProxy1< bool, GdkEventConfigure* > | signal_configure_event ()
| Event triggered by a window resizing.
Glib::SignalProxy1< bool, GdkEventFocus* > | signal_focus_in_event ()
Glib::SignalProxy1< bool, GdkEventFocus* > | signal_focus_out_event ()
Glib::SignalProxy1< bool, GdkEventAny* > | signal_map_event ()
Glib::SignalProxy1< bool, GdkEventAny* > | signal_unmap_event ()
Glib::SignalProxy1< bool, GdkEventProperty* > | signal_property_notify_event ()
Glib::SignalProxy1< bool, GdkEventSelection* > | signal_selection_clear_event ()
Glib::SignalProxy1< bool, GdkEventSelection* > | signal_selection_request_event ()
Glib::SignalProxy1< bool, GdkEventSelection* > | signal_selection_notify_event ()
Glib::SignalProxy1< bool, GdkEventProximity* > | signal_proximity_in_event ()
Glib::SignalProxy1< bool, GdkEventProximity* > | signal_proximity_out_event ()
Glib::SignalProxy1< bool, GdkEventVisibility* > | signal_visibility_notify_event ()
Glib::SignalProxy1< bool, GdkEventWindowState* > | signal_window_state_event ()
Glib::SignalProxy3< void, SelectionData&, guint, guint > | signal_selection_get ()
Glib::SignalProxy2< void, const SelectionData&, guint > | signal_selection_received ()
Glib::SignalProxy1< void, const Glib::RefPtr < Gdk::DragContext >& > | signal_drag_begin ()
Glib::SignalProxy1< void, const Glib::RefPtr < Gdk::DragContext >& > | signal_drag_end ()
Glib::SignalProxy4< void, const Glib::RefPtr < Gdk::DragContext > &, SelectionData&, guint, guint > | signal_drag_data_get ()
Glib::SignalProxy1< void, const Glib::RefPtr < Gdk::DragContext >& > | signal_drag_data_delete ()
Glib::SignalProxy2< bool, const Glib::RefPtr < Gdk::DragContext > &, DragResult > | signal_drag_failed ()
Glib::SignalProxy2< void, const Glib::RefPtr < Gdk::DragContext >&, guint > | signal_drag_leave ()
Glib::SignalProxy4< bool, const Glib::RefPtr < Gdk::DragContext >&, int, int, guint > | signal_drag_motion ()
Glib::SignalProxy4< bool, const Glib::RefPtr < Gdk::DragContext >&, int, int, guint > | signal_drag_drop ()
Glib::SignalProxy6< void, const Glib::RefPtr < Gdk::DragContext >&, int, int, const SelectionData &, guint, guint > | signal_drag_data_received ()
Glib::SignalProxy1< void, const Glib::RefPtr < Gdk::Screen >& > | signal_screen_changed ()
Glib::SignalProxy0< void > | signal_composited_changed ()
Glib::SignalProxy0< bool > | signal_popup_menu ()
Glib::SignalProxy4< bool, int, int, bool, const Glib::RefPtr < Tooltip >& > | signal_query_tooltip ()
Glib::SignalProxy1< bool, GdkEventGrabBroken* > | signal_grab_broken_event ()
Glib::SignalProxy1< bool, GdkEventExpose* > | signal_damage_event ()
Glib::SignalProxy1< bool, GdkEventTouch* > | signal_touch_event ()
Glib::PropertyProxy < Glib::ustring > | property_name ()
| The name of the widget.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_name () const
| The name of the widget.
Glib::PropertyProxy< Container* > | property_parent ()
| The parent widget of this widget.
Glib::PropertyProxy_ReadOnly < Container* > | property_parent () const
| The parent widget of this widget.
Glib::PropertyProxy< int > | property_width_request ()
| Override for width request of the widget, or -1 if natural request should be used.
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Override for width request of the widget, or -1 if natural request should be used.
Glib::PropertyProxy< int > | property_height_request ()
| Override for height request of the widget, or -1 if natural request should be used.
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Override for height request of the widget, or -1 if natural request should be used.
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible.
Glib::PropertyProxy_ReadOnly < bool > | property_visible () const
| Whether the widget is visible.
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input.
Glib::PropertyProxy_ReadOnly < bool > | property_sensitive () const
| Whether the widget responds to input.
Glib::PropertyProxy< bool > | property_app_paintable ()
| Whether the application will paint directly on the widget.
Glib::PropertyProxy_ReadOnly < bool > | property_app_paintable () const
| Whether the application will paint directly on the widget.
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget can accept the input focus.
Glib::PropertyProxy_ReadOnly < bool > | property_can_focus () const
| Whether the widget can accept the input focus.
Glib::PropertyProxy< bool > | property_has_focus ()
| Whether the widget has the input focus.
Glib::PropertyProxy_ReadOnly < bool > | property_has_focus () const
| Whether the widget has the input focus.
Glib::PropertyProxy< bool > | property_is_focus ()
| Whether the widget is the focus widget within the toplevel.
Glib::PropertyProxy_ReadOnly < bool > | property_is_focus () const
| Whether the widget is the focus widget within the toplevel.
Glib::PropertyProxy< bool > | property_can_default ()
| Whether the widget can be the default widget.
Glib::PropertyProxy_ReadOnly < bool > | property_can_default () const
| Whether the widget can be the default widget.
Glib::PropertyProxy< bool > | property_has_default ()
| Whether the widget is the default widget.
Glib::PropertyProxy_ReadOnly < bool > | property_has_default () const
| Whether the widget is the default widget.
Glib::PropertyProxy< bool > | property_receives_default ()
| If TRUE, the widget will receive the default action when it is focused.
Glib::PropertyProxy_ReadOnly < bool > | property_receives_default () const
| If TRUE, the widget will receive the default action when it is focused.
Glib::PropertyProxy_ReadOnly < bool > | property_composite_child () const
| Whether the widget is part of a composite widget.
Glib::PropertyProxy < Glib::RefPtr< Style > > | property_style ()
| The style of the widget, which contains information about how it will look (colors etc).
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Style > > | property_style () const
| The style of the widget, which contains information about how it will look (colors etc).
Glib::PropertyProxy < Gdk::EventMask > | property_events ()
| The event mask that decides what kind of GdkEvents this widget gets.
Glib::PropertyProxy_ReadOnly < Gdk::EventMask > | property_events () const
| The event mask that decides what kind of GdkEvents this widget gets.
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Whether this widget has a tooltip.
Glib::PropertyProxy_ReadOnly < bool > | property_has_tooltip () const
| Whether this widget has a tooltip.
Glib::PropertyProxy < Glib::ustring > | property_tooltip_markup ()
| The contents of the tooltip for this widget.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_tooltip_markup () const
| The contents of the tooltip for this widget.
Glib::PropertyProxy < Glib::ustring > | property_tooltip_text ()
| The contents of the tooltip for this widget.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_tooltip_text () const
| The contents of the tooltip for this widget.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Gdk::Window > > | property_window () const
| The widget's window if it is realized.
Glib::PropertyProxy< bool > | property_no_show_all ()
| Whether gtk_widget_show_all() should not affect this widget.
Glib::PropertyProxy_ReadOnly < bool > | property_no_show_all () const
| Whether gtk_widget_show_all() should not affect this widget.
Glib::PropertyProxy< bool > | property_double_buffered ()
| Whether the widget is double buffered.
Glib::PropertyProxy_ReadOnly < bool > | property_double_buffered () const
| Whether the widget is double buffered.
Glib::PropertyProxy< Align > | property_halign ()
| How to position in extra horizontal space.
Glib::PropertyProxy_ReadOnly < Align > | property_halign () const
| How to position in extra horizontal space.
Glib::PropertyProxy< Align > | property_valign ()
| How to position in extra vertical space.
Glib::PropertyProxy_ReadOnly < Align > | property_valign () const
| How to position in extra vertical space.
Glib::PropertyProxy< int > | property_margin_left ()
| Pixels of extra space on the left side.
Glib::PropertyProxy_ReadOnly< int > | property_margin_left () const
| Pixels of extra space on the left side.
Glib::PropertyProxy< int > | property_margin_right ()
| Pixels of extra space on the right side.
Glib::PropertyProxy_ReadOnly< int > | property_margin_right () const
| Pixels of extra space on the right side.
Glib::PropertyProxy< int > | property_margin_top ()
| Pixels of extra space on the top side.
Glib::PropertyProxy_ReadOnly< int > | property_margin_top () const
| Pixels of extra space on the top side.
Glib::PropertyProxy< int > | property_margin_bottom ()
| Pixels of extra space on the bottom side.
Glib::PropertyProxy_ReadOnly< int > | property_margin_bottom () const
| Pixels of extra space on the bottom side.
Glib::PropertyProxy< int > | property_margin ()
| Pixels of extra space on all four sides.
Glib::PropertyProxy_ReadOnly< int > | property_margin () const
| Pixels of extra space on all four sides.
Glib::PropertyProxy< bool > | property_hexpand ()
| Whether widget wants more horizontal space.
Glib::PropertyProxy_ReadOnly < bool > | property_hexpand () const
| Whether widget wants more horizontal space.
Glib::PropertyProxy< bool > | property_hexpand_set ()
| Whether to use the hexpand property.
Glib::PropertyProxy_ReadOnly < bool > | property_hexpand_set () const
| Whether to use the hexpand property.
Glib::PropertyProxy< bool > | property_vexpand ()
| Whether widget wants more vertical space.
Glib::PropertyProxy_ReadOnly < bool > | property_vexpand () const
| Whether widget wants more vertical space.
Glib::PropertyProxy< bool > | property_vexpand_set ()
| Whether to use the vexpand property.
Glib::PropertyProxy_ReadOnly < bool > | property_vexpand_set () const
| Whether to use the vexpand property.
Glib::PropertyProxy< bool > | property_expand ()
| Whether widget wants to expand in both directions.
Glib::PropertyProxy_ReadOnly < bool > | property_expand () const
| Whether widget wants to expand in both directions.
## Static Public Member Functions
static Widget* | get_current_modal_grab ()
| Retrieve the widget which is currently grabbing all events.
static void | push_composite_child ()
| Makes all newly-created widgets as composite children until the corresponding pop_composite_child() call.
static void | pop_composite_child ()
| Cancels the effect of a previous call to push_composite_child().
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets where the direction has not been explicitly set by set_direction().
static TextDirection | get_default_direction ()
| Obtains the current default reading direction.
static Widget* | drag_get_source_widget (const Glib::RefPtr< Gdk::DragContext >& context)
## Protected Member Functions
virtual void | on_show ()
| This is a default handler for the signal signal_show().
virtual void | on_hide ()
| This is a default handler for the signal signal_hide().
virtual void | on_map ()
| This is a default handler for the signal signal_map().
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap().
virtual void | on_realize ()
| This is a default handler for the signal signal_realize().
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize().
virtual void | on_size_allocate (Allocation& allocation)
| This is a default handler for the signal signal_size_allocate().
virtual void | on_state_changed (Gtk::StateType previous_state)
| This is a default handler for the signal signal_state_changed().
virtual void | on_parent_changed (Widget* previous_parent)
| This is a default handler for the signal signal_parent_changed().
virtual void | on_hierarchy_changed (Widget* previous_toplevel)
| This is a default handler for the signal signal_hierarchy_changed().
virtual void | on_style_updated ()
| This is a default handler for the signal signal_style_updated().
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed().
virtual void | on_grab_notify (bool was_grabbed)
| This is a default handler for the signal signal_grab_notify().
virtual void | on_child_notify (GParamSpec* pspec)
| This is a default handler for the signal signal_child_notify().
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate().
virtual void | on_grab_focus ()
| This is a default handler for the signal signal_grab_focus().
virtual bool | on_focus (DirectionType direction)
| This is a default handler for the signal signal_focus().
virtual bool | on_event (GdkEvent*event)
| This is a default handler for the signal signal_event().
virtual bool | on_button_press_event (GdkEventButton*event)
| This is a default handler for the signal signal_button_press_event().
virtual bool | on_button_release_event (GdkEventButton*event)
| This is a default handler for the signal signal_button_release_event().
virtual bool | on_scroll_event (GdkEventScroll*event)
| This is a default handler for the signal signal_scroll_event().
virtual bool | on_motion_notify_event (GdkEventMotion*event)
| This is a default handler for the signal signal_motion_notify_event().
virtual bool | on_delete_event (GdkEventAny*event)
| This is a default handler for the signal signal_delete_event().
virtual bool | on_draw (const ::Cairo::RefPtr< ::Cairo::Context >& cr)
| This is a default handler for the signal signal_draw().
virtual bool | on_key_press_event (GdkEventKey*event)
| This is a default handler for the signal signal_key_press_event().
virtual bool | on_key_release_event (GdkEventKey*event)
| This is a default handler for the signal signal_key_release_event().
virtual bool | on_enter_notify_event (GdkEventCrossing*event)
| This is a default handler for the signal signal_enter_notify_event().
virtual bool | on_leave_notify_event (GdkEventCrossing*event)
| This is a default handler for the signal signal_leave_notify_event().
virtual bool | on_configure_event (GdkEventConfigure*event)
| This is a default handler for the signal signal_configure_event().
virtual bool | on_focus_in_event (GdkEventFocus*event)
| This is a default handler for the signal signal_focus_in_event().
virtual bool | on_focus_out_event (GdkEventFocus*event)
| This is a default handler for the signal signal_focus_out_event().
virtual bool | on_map_event (GdkEventAny*event)
| This is a default handler for the signal signal_map_event().
virtual bool | on_unmap_event (GdkEventAny*event)
| This is a default handler for the signal signal_unmap_event().
virtual bool | on_property_notify_event (GdkEventProperty*event)
| This is a default handler for the signal signal_property_notify_event().
virtual bool | on_selection_clear_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_clear_event().
virtual bool | on_selection_request_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_request_event().
virtual bool | on_selection_notify_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_notify_event().
virtual bool | on_proximity_in_event (GdkEventProximity*event)
| This is a default handler for the signal signal_proximity_in_event().
virtual bool | on_proximity_out_event (GdkEventProximity*event)
| This is a default handler for the signal signal_proximity_out_event().
virtual bool | on_visibility_notify_event (GdkEventVisibility*event)
| This is a default handler for the signal signal_visibility_notify_event().
virtual bool | on_window_state_event (GdkEventWindowState*event)
| This is a default handler for the signal signal_window_state_event().
virtual void | on_selection_get (SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_selection_get().
virtual void | on_selection_received (const SelectionData& selection_data, guint time)
| This is a default handler for the signal signal_selection_received().
virtual void | on_drag_begin (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_begin().
virtual void | on_drag_end (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_end().
virtual void | on_drag_data_get (const Glib::RefPtr< Gdk::DragContext >& context, SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_get().
virtual void | on_drag_data_delete (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_data_delete().
virtual void | on_drag_leave (const Glib::RefPtr< Gdk::DragContext >& context, guint time)
| This is a default handler for the signal signal_drag_leave().
virtual bool | on_drag_motion (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_motion().
virtual bool | on_drag_drop (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_drop().
virtual void | on_drag_data_received (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, const SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_received().
virtual void | on_screen_changed (const Glib::RefPtr< Gdk::Screen >& previous_screen)
| This is a default handler for the signal signal_screen_changed().
virtual void | dispatch_child_properties_changed_vfunc (guint p1, GParamSpec** p2)
virtual void | show_all_vfunc ()
virtual Glib::RefPtr< Atk::Object > | get_accessible_vfunc ()
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | get_preferred_width_vfunc (int& minimum_width, int& natural_width) const
virtual void | get_preferred_height_for_width_vfunc (int width, int& minimum_height, int& natural_height) const
virtual void | get_preferred_height_vfunc (int& minimum_height, int& natural_height) const
virtual void | get_preferred_width_for_height_vfunc (int height, int& minimum_width, int& natural_width) const
| Widget ()
void | realize ()
| Creates the GDK (windowing system) resources associated with a widget.
void | unrealize ()
| This function is only useful in widget implementations.
void | draw (const ::Cairo::RefPtr< ::Cairo::Context >& cr)
| Draws widget to cr.
void | set_mapped (bool mapped=true)
| Marks the widget as being realized.
void | set_realized (bool realized=true)
| Marks the widget as being realized.
void | set_has_window (bool has_window=true)
| Specifies whether widget has a Gdk::Window of its own.
void | set_window (const Glib::RefPtr< Gdk::Window >& window)
| Sets a widget's window.
void | transform_cairo_context_to_window (const ::Cairo::RefPtr< ::Cairo::Context >& cr, const Glib::RefPtr< const Gdk::Window >& window)
| Transforms the given cairo context cr from widget-relative coordinates to window-relative coordinates.
Requisition | get_requisition () const
| Retrieves the widget's requisition.
void | get_style_property_value (const Glib::ustring& the_property_name, Glib::ValueBase&value) const
| Gets the value of a style property of widget.
void | realize_if_needed ()
## Static Protected Member Functions
static bool | should_draw_window (const ::Cairo::RefPtr< const ::Cairo::Context >& cr, const Glib::RefPtr< const Gdk::Window >& window)
| This function is supposed to be called in Gtk::Widget::signal_draw() implementations for widgets that support multiple windows.
## Related Functions
(Note that these are not member functions.)
Gtk::Widget* | wrap (GtkWidget* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Abstract Widget (Base class for all widgets)

As the base class of all widgets this contains all of the properties and methods common to all widgets. It is an abstract class that can not be instantiated.

Important part of widgets are the *_event signals and virtual methods that every widget have. Those are events coming directly from gdk and thus also from XLib. By overriding those virtual methods you can trap everything a widget can ever do. In order to capture events from a widget, the event mask must first be set with ().

Only widgets with a Gdk::Window on the server side are allowed to capture events. Widgets in the Gtk::Misc group for example lack a Gdk::Window.

## Constructor & Destructor Documentation

virtual Gtk::Widget::~Widget | ( |  | ) | `[virtual]`

Destroys the widget.

The widget will be automatically removed from the parent container.

Gtk::Widget::Widget | ( |  | ) | `[protected]`

## Member Function Documentation

bool Gtk::Widget::activate | ( |  | ) |

For widgets that can be "activated" (buttons, menu items, etc.) this function activates them.

Activation is what happens when you press Enter on a widget during key navigation. If widget isn't activatable, the function returns `false`.

Returns:
  `true` if the widget was activatable.

Reimplemented in Gtk::MenuItem.

void Gtk::Widget::add_accelerator | ( | const Glib::ustring & | accel_signal,
|  | const Glib::RefPtr< AccelGroup >& | accel_group,
|  | guint | accel_key,
|  | Gdk::ModifierType | accel_mods,
|  | AccelFlags | accel_flags
| ) |  |

Installs an accelerator for this widget in accel_group that causes accel_signal to be emitted if the accelerator is activated.

The accel_group needs to be added to the widget's toplevel via Gtk::Window::add_accel_group(), and the signal must be of type RUN_ACTION. Accelerators added through this function are not user changeable during runtime. If you want to support accelerators that can be changed by the user, use Gtk::AccelMap::add_entry() and set_accel_path() or Gtk::MenuItem::set_accel_path() instead.

Parameters:

  accel_signal | Widget signal to emit on accelerator activation.
  accel_group | Accel group for this widget, added to its toplevel.
  accel_key | GDK keyval of the accelerator.
  accel_mods | Modifier key combination of the accelerator.
  accel_flags | Flag accelerators, e.g. Gtk::ACCEL_VISIBLE.

void Gtk::Widget::add_device_events | ( | const Glib::RefPtr< const Gdk::Device >& | device,
|  | Gdk::EventMask | events
| ) |  |

Adds the device events in the bitfield events to the event mask for widget.

See set_device_events() for details.

Since gtkmm 3.0:

Parameters:

  device | A Gdk::Device.
  events | An event mask, see Gdk::EventMask.

void Gtk::Widget::add_events | ( | Gdk::EventMask | events | ) |

Adds the events in the bitfield events to the event mask for widget.

See set_events() for details.

Parameters:

  events | An event mask, see Gdk::EventMask.

void Gtk::Widget::add_mnemonic_label | ( | Widget& | label | ) |

Adds a widget to the list of mnemonic labels for this widget.

(See list_mnemonic_labels()). Note the list of mnemonic labels for the widget is cleared when the widget is destroyed, so the caller must make sure to update its internal state at this point as well.

Since gtkmm 2.4:

Parameters:

  label | A Gtk::Widget that acts as a mnemonic label for widget.

void Gtk::Widget::add_modal_grab | ( |  | ) |

Block events to everything else than this widget and its children.

This way you can get modal behaviour (usually not recommended). One practical example could be when implementing a key-binding widget that needs exclusive access to the key combination that the user presses next.

Calls to add_modal_grab should be paired with calls to remove_modal_grab.

bool Gtk::Widget::child_focus | ( | DirectionType | direction | ) |

This function is used by custom widget implementations; if you're writing an app, you'd use grab_focus() to move the focus to a particular widget, and Gtk::Container::set_focus_chain() to change the focus tab order.

So you may want to investigate those functions instead.

child_focus() is called by containers as the user moves around the window using keyboard shortcuts. direction indicates what kind of motion is taking place (up, down, left, right, tab forward, tab backward). child_focus() emits the Gtk::Widget::signal_focus() signal; widgets override the default handler for this signal in order to implement appropriate focus behavior.

The default signal_focus() handler for a widget should return `true` if moving in direction left the focus on a focusable location inside that widget, and `false` if moving in direction moved the focus outside the widget. If returning `true`, widgets normally call grab_focus() to place the focus accordingly; if returning `false`, they don't modify the current focus location.

Parameters:

  direction | Direction of focus movement.

Returns:
  `true` if focus ended up inside widget.

void Gtk::Widget::child_notify | ( | const Glib::ustring & | child_property | ) |

Emits a Gtk::Widget::signal_child_notify() signal for the child property child_property on widget.

This is the analogue of Glib::object_notify() for child properties.

Also see Gtk::Container::child_notify().

Parameters:

  child_property | The name of a child property installed on the class of widget's parent.

bool Gtk::Widget::compute_expand | ( | Orientation | orientation | ) |

Computes whether a container should give this widget extra space when possible.

Containers should check this, rather than looking at get_hexpand() or get_vexpand().

This function already checks whether the widget is visible, so visibility does not need to be checked separately. Non-visible widgets are not expanded.

The computed expand value uses either the expand setting explicitly set on the widget itself, or, if none has been explicitly set, the widget may expand if some of its children do.

Parameters:

  orientation | Expand direction.

Returns:
  Whether widget tree rooted here should be expanded.

Glib::RefPtr<Pango::Context> Gtk::Widget::create_pango_context | ( |  | ) |

Creates a new Pango::Context with the appropriate font map, font description, and base direction for drawing text for this widget.

See also get_pango_context().

Returns:
  The new Pango::Context.

Glib::RefPtr<Pango::Layout> Gtk::Widget::create_pango_layout | ( | const Glib::ustring & | text | ) |

Creates a new Pango::Layout with the appropriate font map, font description, and base direction for drawing text for this widget.

If you keep a Pango::Layout created in this way around, in order to notify the layout of changes to the base direction or font of this widget, you must call pango_layout_context_changed() in response to the Gtk::Widget::signal_style_updated() and Gtk::Widget::signal_direction_changed() signals for the widget.

Parameters:

  text | Text to set on the layout (can be `0`).

Returns:
  The new Pango::Layout.

bool Gtk::Widget::device_is_shadowed | ( | const Glib::RefPtr< const Gdk::Device >& | device | ) |

Returns `true` if device has been shadowed by a GTK+ device grab on another widget, so it would stop sending events to widget.

This may be used in the Gtk::Widget::signal_grab_notify() signal to check for specific devices. See gtk_device_grab_add().

Since gtkmm 3.0:

Parameters:

  device | A Gdk::Device.

Returns:
  `true` if there is an ongoing grab on device by another Gtk::Widget than widget.

virtual void Gtk::Widget::dispatch_child_properties_changed_vfunc | ( | guint | p1,
|  | GParamSpec ** | p2
| ) |  | `[protected, virtual]`

Glib::RefPtr<Gdk::DragContext> Gtk::Widget::drag_begin | ( | const Glib::RefPtr< TargetList >& | targets,
|  | Gdk::DragAction | actions,
|  | int | button,
|  | GdkEvent * | event
| ) |  |

Initiates a drag on the source side.

The function only needs to be used when the application is starting drags itself, and is not needed when Gtk::DragSource::set() is used.

The event is used to retrieve the timestamp that will be used internally to grab the pointer. If event is #`0`, then GDK_CURRENT_TIME will be used. However, you should try to pass a real event in all cases, since that can be used by GTK+ to get information about the start position of the drag, for example if the event is a Gdk::MOTION_NOTIFY.

Generally there are three cases when you want to start a drag by hand by calling this function:

1. During a Gtk::Widget::signal_button_press_event() handler, if you want to start a drag immediately when the user presses the mouse button. Pass the event that you have in your Gtk::Widget::signal_button_press_event() handler.

2. During a Gtk::Widget::signal_motion_notify_event() handler, if you want to start a drag when the mouse moves past a certain threshold distance after a button-press. Pass the event that you have in your Gtk::Widget::signal_motion_notify_event() handler.

3. During a timeout handler, if you want to start a drag after the mouse button is held down for some time. Try to save the last event that you got from the mouse, using gdk_event_copy(), and pass it to this function (remember to free the event with gdk_event_free() when you are done). If you can really not pass a real event, pass #`0` instead.

Parameters:

  targets | The targets (data formats) in which the source can provide the data.
  actions | A bitmask of the allowed drag actions for this drag.
  button | The button the user clicked to start the drag.
  event | The event that triggered the start of the drag.

Returns:
  The context for this drag.

bool Gtk::Widget::drag_check_threshold | ( | int | start_x,
|  | int | start_y,
|  | int | current_x,
|  | int | current_y
| ) |  |

Checks to see if a mouse drag starting at ( start_x, start_y) and ending at ( current_x, current_y) has passed the GTK+ drag threshold, and thus should trigger the beginning of a drag-and-drop operation.

Parameters:

  start_x | X coordinate of start of drag.
  start_y | Y coordinate of start of drag.
  current_x | Current X coordinate.
  current_y | Current Y coordinate.

Returns:
  `true` if the drag threshold has been passed.

void Gtk::Widget::drag_dest_add_image_targets | ( |  | ) |

Add the image targets supported by Gtk::Selection to the target list of the drag destination.

The targets are added with info = 0. If you need another value, use Gtk::TargetList::add_image_targets() and gtk_drag_dest_set_target_list().

Since gtkmm 2.6:

Parameters:

  widget | A Gtk::Widget that's a drag destination.

void Gtk::Widget::drag_dest_add_text_targets | ( |  | ) |

Add the text targets supported by Gtk::Selection to the target list of the drag destination.

The targets are added with info = 0. If you need another value, use Gtk::TargetList::add_text_targets() and gtk_drag_dest_set_target_list().

Since gtkmm 2.6:

Parameters:

  widget | A Gtk::Widget that's a drag destination.

void Gtk::Widget::drag_dest_add_uri_targets | ( |  | ) |

Add the URI targets supported by Gtk::Selection to the target list of the drag destination.

The targets are added with info = 0. If you need another value, use Gtk::TargetList::add_uri_targets() and gtk_drag_dest_set_target_list().

Since gtkmm 2.6:

Parameters:

  widget | A Gtk::Widget that's a drag destination.

Glib::ustring Gtk::Widget::drag_dest_find_target | ( | const Glib::RefPtr< Gdk::DragContext >& | context,
|  | const Glib::RefPtr< TargetList >& | target_list
| ) |  | const

Looks for a match between context->targets and the dest_target_list, returning the first matching target, otherwise returning Gdk::NONE.

dest_target_list should usually be the return value from gtk_drag_dest_get_target_list(), but some widgets may have different valid targets for different parts of the widget; in that case, they will have to implement a drag_motion handler that passes the correct target list to this function.

Parameters:

  context | Drag context.
  target_list | List of droppable targets.

Returns:
  First target that the source offers and the dest can accept, or Gdk::NONE.

Glib::ustring Gtk::Widget::drag_dest_find_target | ( | const Glib::RefPtr< Gdk::DragContext >& | context | ) | const

Glib::RefPtr<TargetList> Gtk::Widget::drag_dest_get_target_list | ( |  | ) |

Returns the list of targets this widget can accept from drag-and-drop.

Returns:
  The Gtk::TargetList, or `0` if none.

Glib::RefPtr<const TargetList> Gtk::Widget::drag_dest_get_target_list | ( |  | ) | const

Returns the list of targets this widget can accept from drag-and-drop.

Returns:
  The Gtk::TargetList, or `0` if none.

void Gtk::Widget::drag_dest_set | ( | DestDefaults | flags = `DestDefaults(0)`,
|  | Gdk::DragAction | actions = `Gdk::DragAction(0)`
| ) |  |

void Gtk::Widget::drag_dest_set | ( | const std::vector< TargetEntry >& | targets,
|  | DestDefaults | flags = `DEST_DEFAULT_ALL`,
|  | Gdk::DragAction | actions = `Gdk::ACTION_COPY`
| ) |  |

void Gtk::Widget::drag_dest_set_proxy | ( | const Glib::RefPtr< Gdk::Window >& | proxy_window,
|  | Gdk::DragProtocol | protocol,
|  | bool | use_coordinates
| ) |  |

Sets this widget as a proxy for drops to another window.

Parameters:

  widget | A Gtk::Widget.
  proxy_window | The window to which to forward drag events.
  protocol | The drag protocol which the proxy_window accepts (You can use gdk_drag_get_protocol() to determine this).
  use_coordinates | If `true`, send the same coordinates to the destination, because it is an embedded subwindow.

void Gtk::Widget::drag_dest_set_target_list | ( | const Glib::RefPtr< TargetList >& | target_list | ) |

Sets the target types that this widget can accept from drag-and-drop.

The widget must first be made into a drag destination with gtk_drag_dest_set().

Parameters:

  target_list | List of droppable targets, or `0` for none.

void Gtk::Widget::drag_dest_unset | ( |  | ) |

Clears information about a drop destination set with gtk_drag_dest_set().

The widget will no longer receive notification of drags.

Parameters:

  widget | A Gtk::Widget.

void Gtk::Widget::drag_get_data | ( | const Glib::RefPtr< Gdk::DragContext >& | context,
|  | const Glib::ustring & | target,
|  | guint32 | time
| ) |  |

Gets the data associated with a drag.

When the data is received or the retrieval fails, GTK+ will emit a Gtk::Widget::signal_drag_data_received() signal. Failure of the retrieval is indicated by the length field of the selection_data signal parameter being negative. However, when gtk_drag_get_data() is called implicitely because the Gtk::DEST_DEFAULT_DROP was set, then the widget will not receive notification of failed drops.

Parameters:

  widget | The widget that will receive the Gtk::Widget::signal_drag_data_received() signal.
  context | The drag context.
  target | The target (form of the data) to retrieve.
  time | A timestamp for retrieving the data. This will generally be the time received in a Gtk::Widget::signal_drag_motion()" or Gtk::Widget::signal_drag_drop()" signal.

static Widget* Gtk::Widget::drag_get_source_widget | ( | const Glib::RefPtr< Gdk::DragContext >& | context | ) | `[static]`

void Gtk::Widget::drag_highlight | ( |  | ) |

Draws a highlight around a widget.

This will attach handlers to Gtk::Widget::signal_draw(), so the highlight will continue to be displayed until gtk_drag_unhighlight() is called.

Parameters:

  widget | A widget to highlight.

void Gtk::Widget::drag_set_as_icon | ( | const Glib::RefPtr< Gdk::DragContext >& | context,
|  | int | hot_x,
|  | int | hot_y
| ) |  |

void Gtk::Widget::drag_source_add_image_targets | ( |  | ) |

Add the writable image targets supported by Gtk::Selection to the target list of the drag source.

The targets are added with info = 0. If you need another value, use Gtk::TargetList::add_image_targets() and set_target_list().

Since gtkmm 2.6:

Parameters:

  widget | A Gtk::Widget that's is a drag source.

void Gtk::Widget::drag_source_add_text_targets | ( |  | ) |

Add the text targets supported by Gtk::Selection to the target list of the drag source.

The targets are added with info = 0. If you need another value, use Gtk::TargetList::add_text_targets() and set_target_list().

Since gtkmm 2.6:

Parameters:

  widget | A Gtk::Widget that's is a drag source.

void Gtk::Widget::drag_source_add_uri_targets | ( |  | ) |

Add the URI targets supported by Gtk::Selection to the target list of the drag source.

The targets are added with info = 0. If you need another value, use Gtk::TargetList::add_uri_targets() and set_target_list().

Since gtkmm 2.6:

Parameters:

  widget | A Gtk::Widget that's is a drag source.

void Gtk::Widget::drag_source_set | ( | const std::vector< TargetEntry >& | targets,
|  | Gdk::ModifierType | start_button_mask = `Gdk::MODIFIER_MASK`,
|  | Gdk::DragAction | actions = `Gdk::ACTION_COPY`
| ) |  |

void Gtk::Widget::drag_source_set_icon | ( | const Glib::RefPtr< Gdk::Pixbuf >& | pixbuf | ) |

Sets the icon that will be used for drags from a particular widget from a Gdk::Pixbuf.

GTK+ retains a reference for pixbuf and will release it when it is no longer needed.

Parameters:

  pixbuf | The Gdk::Pixbuf for the drag icon.

void Gtk::Widget::drag_source_set_icon | ( | const StockID& | stock_id | ) |

Sets the icon that will be used for drags from a particular source to a stock icon.

Parameters:

  stock_id | The ID of the stock icon to use.

void Gtk::Widget::drag_source_set_icon | ( | const Glib::ustring & | icon_name | ) |

Sets the icon that will be used for drags from a particular source to a themed icon.

See the docs for Gtk::IconTheme for more details.

Since gtkmm 2.8:

Parameters:

  widget | A Gtk::Widget.
  icon_name | Name of icon to use.

void Gtk::Widget::drag_source_unset | ( |  | ) |

Undoes the effects of set().

Parameters:

  widget | A Gtk::Widget.

void Gtk::Widget::drag_unhighlight | ( |  | ) |

Removes a highlight set by gtk_drag_highlight() from a widget.

Parameters:

  widget | A widget to remove the highlight from.

void Gtk::Widget::draw | ( | const ::Cairo::RefPtr< ::Cairo::Context > & | cr | ) | `[protected]`

Draws widget to cr.

The top left corner of the widget will be drawn to the currently set origin point of cr.

You should pass a cairo context as cr argument that is in an original state. Otherwise the resulting drawing is undefined. For example changing the operator using cairo_set_operator() or the line width using cairo_set_line_width() might have unwanted side effects. You may however change the context's transform matrix - like with cairo_scale(), cairo_translate() or cairo_set_matrix() and clip region with cairo_clip() prior to calling this function. Also, it is fine to modify the context with cairo_save() and cairo_push_group() prior to calling this function.

<note>Special purpose widgets may contain special code for rendering to the screen and might appear differently on screen and when rendered using draw().</note>

Since gtkmm 3.0:

Parameters:

  cr | A cairo context to draw to.

void Gtk::Widget::draw_insertion_cursor | ( | const ::Cairo::RefPtr< ::Cairo::Context > & | cr,
|  | const Gdk::Rectangle& | location,
|  | bool | is_primary,
|  | TextDirection | direction,
|  | bool | draw_arrow = `true`
| ) |  |

void Gtk::Widget::error_bell | ( |  | ) |

Notifies the user about an input-related error on this widget.

If the Gtk::Settings gtk-error-bell proeprty is true, it calls Gdk::Window::beep(), otherwise it does nothing.

Note that the effect of Gdk::Window::beep() can be configured in many ways, depending on the windowing backend and the desktop environment or window manager that is used.

Since gtkmm 2.12:

bool Gtk::Widget::event | ( | GdkEvent * | event | ) |

Rarely-used function.

This function is used to emit the event signals on a widget (those signals should never be emitted without using this function to do so). If you want to synthesize an event though, don't use this function; instead, use gtk_main_do_event() so the event will behave as if it were in the event queue. Don't synthesize expose events; instead, use gdk_window_invalidate_rect() to invalidate a region of the window.

Parameters:

  event | A Gdk::Event.

Returns:
  Return from the event signal emission (`true` if the event was handled).

void Gtk::Widget::freeze_child_notify | ( |  | ) |

Stops emission of Gtk::Widget::signal_child_notify() signals on widget.

The signals are queued until thaw_child_notify() is called on widget.

This is the analogue of Glib::object_freeze_notify() for child properties.

Glib::RefPtr<Atk::Object> Gtk::Widget::get_accessible | ( |  | ) |

Returns the accessible object that describes the widget to an assistive technology.

If accessibility support is not available, this Atk::Object instance may be a no-op. Likewise, if no class-specific Atk::Object implementation is available for the widget instance in question, it will inherit an Atk::Object implementation from the first ancestor class for which such an implementation is defined.

The documentation of the ATK library contains more information about accessible objects and their uses.

Returns:
  The Atk::Object associated with widget.

Glib::RefPtr<const Atk::Object> Gtk::Widget::get_accessible | ( |  | ) | const

Returns the accessible object that describes the widget to an assistive technology.

If accessibility support is not available, this Atk::Object instance may be a no-op. Likewise, if no class-specific Atk::Object implementation is available for the widget instance in question, it will inherit an Atk::Object implementation from the first ancestor class for which such an implementation is defined.

The documentation of the ATK library contains more information about accessible objects and their uses.

Returns:
  The Atk::Object associated with widget.

virtual Glib::RefPtr<Atk::Object> Gtk::Widget::get_accessible_vfunc | ( |  | ) | `[protected, virtual]`

int Gtk::Widget::get_allocated_height | ( |  | ) | const

Returns the height that has currently been allocated to widget.

This function is intended to be used when implementing handlers for the Gtk::Widget::signal_draw() function.

Returns:
  The height of the widget.

int Gtk::Widget::get_allocated_width | ( |  | ) | const

Returns the width that has currently been allocated to widget.

This function is intended to be used when implementing handlers for the Gtk::Widget::signal_draw() function.

Returns:
  The width of the widget.

Allocation Gtk::Widget::get_allocation | ( |  | ) | const

Retrieves the widget's location.

Note, when implementing a Container: a widget's allocation will be its "adjusted" allocation, that is, the widget's parent container typically calls size_allocate() with an allocation, and that allocation is then adjusted (to handle margin and alignment for example) before assignment to the widget. get_allocation() returns the adjusted allocation that was actually assigned to the widget. The adjusted allocation is guaranteed to be completely contained within the size_allocate() allocation, however. So a Container is guaranteed that its children stay inside the assigned bounds, but not that they have exactly the bounds the container assigned. There is no way to get the original allocation assigned by size_allocate(), since it isn't stored. If a container implementation needs that information it will have to track it itself.

Returns:
  The widget's allocated area.

Widget* Gtk::Widget::get_ancestor | ( | GType | widget_type | ) |

Gets the first ancestor of widget with type widget_type.

For example, `gtk_widget_get_ancestor (widget, GTK_TYPE_BOX)` gets the first Gtk::Box that's an ancestor of widget. No reference will be added to the returned widget; it should not be unreferenced. See note about checking for a toplevel Gtk::Window in the docs for get_toplevel().

Note that unlike is_ancestor(), get_ancestor() considers widget to be an ancestor of itself.

Parameters:

  widget_type | Ancestor type.

Returns:
  The ancestor widget, or `0` if not found.

const Widget* Gtk::Widget::get_ancestor | ( | GType | widget_type | ) | const

Gets the first ancestor of widget with type widget_type.

For example, `gtk_widget_get_ancestor (widget, GTK_TYPE_BOX)` gets the first Gtk::Box that's an ancestor of widget. No reference will be added to the returned widget; it should not be unreferenced. See note about checking for a toplevel Gtk::Window in the docs for get_toplevel().

Note that unlike is_ancestor(), get_ancestor() considers widget to be an ancestor of itself.

Parameters:

  widget_type | Ancestor type.

Returns:
  The ancestor widget, or `0` if not found.

bool Gtk::Widget::get_app_paintable | ( |  | ) | const

Determines whether the application intends to draw on the widget in an Gtk::Widget::signal_draw() handler.

See set_app_paintable()

Since gtkmm 2.18:

Returns:
  `true` if the widget is app paintable.

bool Gtk::Widget::get_can_default | ( |  | ) | const

Determines whether widget can be a default widget.

See set_can_default().

Since gtkmm 2.18:

Returns:
  `true` if widget can be a default widget, `false` otherwise.

bool Gtk::Widget::get_can_focus | ( |  | ) | const

Determines whether widget can own the input focus.

See set_can_focus().

Since gtkmm 2.18:

Returns:
  `true` if widget can own the input focus, `false` otherwise.

bool Gtk::Widget::get_child_visible | ( |  | ) | const

Gets the value set with set_child_visible().

If you feel a need to use this function, your code probably needs reorganization.

This function is only useful for container implementations and never should be called by an application.

Returns:
  `true` if the widget is mapped with the parent.

Glib::RefPtr<Clipboard> Gtk::Widget::get_clipboard | ( | const Glib::ustring & | selection | ) |

Returns the clipboard object for the given selection to be used with widget.

widget must have a Gdk::Display associated with it, so must be attached to a toplevel window.

Since gtkmm 2.2:

Parameters:

  selection | A Gdk::Atom which identifies the clipboard to use. Gdk::SELECTION_CLIPBOARD gives the default clipboard. Another common value is Gdk::SELECTION_PRIMARY, which gives the primary X selection.

Returns:
  The appropriate clipboard object. If no clipboard already exists, a new one will be created. Once a clipboard object has been created, it is persistent for all time.

Glib::RefPtr<const Clipboard> Gtk::Widget::get_clipboard | ( | const Glib::ustring & | selection | ) | const

Returns the clipboard object for the given selection to be used with widget.

widget must have a Gdk::Display associated with it, so must be attached to a toplevel window.

Since gtkmm 2.2:

Parameters:

  selection | A Gdk::Atom which identifies the clipboard to use. Gdk::SELECTION_CLIPBOARD gives the default clipboard. Another common value is Gdk::SELECTION_PRIMARY, which gives the primary X selection.

Returns:
  The appropriate clipboard object. If no clipboard already exists, a new one will be created. Once a clipboard object has been created, it is persistent for all time.

Glib::ustring Gtk::Widget::get_composite_name | ( |  | ) | const

Obtains the composite name of a widget.

Returns:
  The composite name of widget, or an emoty string if widget is not a composite child.

static Widget* Gtk::Widget::get_current_modal_grab | ( |  | ) | `[static]`

Retrieve the widget which is currently grabbing all events.

static TextDirection Gtk::Widget::get_default_direction | ( |  | ) | `[static]`

Obtains the current default reading direction.

See set_default_direction().

Returns:
  The current default direction.

bool Gtk::Widget::get_device_enabled | ( | const Glib::RefPtr< const Gdk::Device >& | device | ) | const

Returns whether device can interact with widget and its children.

See set_device_enabled().

Since gtkmm 3.0:

Parameters:

  device | A Gdk::Device.

Returns:
  `true` is device is enabled for widget.

Gdk::EventMask Gtk::Widget::get_device_events | ( | const Glib::RefPtr< const Gdk::Device >& | device | ) | const

Returns the events mask for the widget corresponding to an specific device.

These are the events that the widget will receive when device operates on it.

Since gtkmm 3.0:

Parameters:

  device | A Gdk::Device.

Returns:
  Device event mask for widget.

TextDirection Gtk::Widget::get_direction | ( |  | ) | const

Gets the reading direction for a particular widget.

See set_direction().

Returns:
  The reading direction for the widget.

Glib::RefPtr<Gdk::Display> Gtk::Widget::get_display | ( |  | ) |

Get the Gdk::Display for the toplevel window associated with this widget.

This function can only be called after the widget has been added to a widget hierarchy with a Gtk::Window at the top.

In general, you should only create display specific resources when a widget has been realized, and you should free those resources when the widget is unrealized.

Since gtkmm 2.2:

Returns:
  The Gdk::Display for the toplevel for this widget.

Glib::RefPtr<const Gdk::Display> Gtk::Widget::get_display | ( |  | ) | const

Get the Gdk::Display for the toplevel window associated with this widget.

This function can only be called after the widget has been added to a widget hierarchy with a Gtk::Window at the top.

In general, you should only create display specific resources when a widget has been realized, and you should free those resources when the widget is unrealized.

Since gtkmm 2.2:

Returns:
  The Gdk::Display for the toplevel for this widget.

bool Gtk::Widget::get_double_buffered | ( |  | ) | const

Determines whether the widget is double buffered.

See set_double_buffered()

Since gtkmm 2.18:

Returns:
  `true` if the widget is double buffered.

Gdk::EventMask Gtk::Widget::get_events | ( |  | ) | const

Returns the event mask for the widget (a bitfield containing flags from the Gdk::EventMask enumeration).

These are the events that the widget will receive.

Returns:
  Event mask for widget.

Align Gtk::Widget::get_halign | ( |  | ) | const

Gets the value of the Gtk::Widget::property_halign() property.

Returns:
  The horizontal alignment of widget.

bool Gtk::Widget::get_has_tooltip | ( |  | ) | const

Returns the current value of the has-tooltip property.

See Gtk::Widget::property_has_tooltip() for more information.

Since gtkmm 2.12:

Returns:
  Current value of has-tooltip on widget.

bool Gtk::Widget::get_has_window | ( |  | ) | const

Determines whether widget has a Gdk::Window of its own.

See set_has_window().

Since gtkmm 2.18:

Returns:
  `true` if widget has a window, `false` otherwise.

int Gtk::Widget::get_height | ( |  | ) | const

bool Gtk::Widget::get_hexpand | ( |  | ) | const

Gets whether the widget would like any available extra horizontal space.

When a user resizes a Gtk::Window, widgets with expand=`true` generally receive the extra space. For example, a list or scrollable area or document in your window would often be set to expand.

Containers should use compute_expand() rather than this function, to see whether a widget, or any of its children, has the expand flag set. If any child of a widget wants to expand, the parent may ask to expand also.

This function only looks at the widget's own hexpand flag, rather than computing whether the entire widget tree rooted at this widget wants to expand.

Returns:
  Whether hexpand flag is set.

bool Gtk::Widget::get_hexpand_set | ( |  | ) | const

Gets whether set_hexpand() has been used to explicitly set the expand flag on this widget.

If hexpand is set, then it overrides any computed expand value based on child widgets. If hexpand is not set, then the expand value depends on whether any children of the widget would like to expand.

There are few reasons to use this function, but it's here for completeness and consistency.

Returns:
  Whether hexpand has been explicitly set.

bool Gtk::Widget::get_is_drawable | ( |  | ) | const

Determines whether widget can be drawn to.

A widget can be drawn to if it is mapped and visible.

Since gtkmm 2.18:

Returns:
  `true` if widget is drawable, `false` otherwise.

bool Gtk::Widget::get_is_toplevel | ( |  | ) | const

Determines whether widget is a toplevel widget.

Currently only Gtk::Window and Gtk::Invisible (and out-of-process Gtk::Plugs) are toplevel widgets. Toplevel widgets have no parent widget.

Since gtkmm 2.18:

Returns:
  `true` if widget is a toplevel, `false` otherwise.

bool Gtk::Widget::get_mapped | ( |  | ) | const

Whether the widget is mapped.

Since gtkmm 2.20:

Returns:
  `true` if the widget is mapped, `false` otherwise.

int Gtk::Widget::get_margin_bottom | ( |  | ) | const

Gets the value of the Gtk::Widget::property_margin_bottom() property.

Since gtkmm 3.0:

Returns:
  The bottom margin of widget.

int Gtk::Widget::get_margin_left | ( |  | ) | const

Gets the value of the Gtk::Widget::property_margin_left() property.

Since gtkmm 3.0:

Returns:
  The left margin of widget.

int Gtk::Widget::get_margin_right | ( |  | ) | const

Gets the value of the Gtk::Widget::property_margin_right() property.

Since gtkmm 3.0:

Returns:
  The right margin of widget.

int Gtk::Widget::get_margin_top | ( |  | ) | const

Gets the value of the Gtk::Widget::property_margin_top() property.

Since gtkmm 3.0:

Returns:
  The top margin of widget.

Gdk::ModifierType Gtk::Widget::get_modifier_mask | ( | Gdk::ModifierIntent | intent | ) |

Returns the modifier mask the widget's windowing system backend uses for a particular purpose.

See gdk_keymap_get_modifier_mask().

Since gtkmm 3.4:

Parameters:

  intent | The use case for the modifier mask.

Returns:
  The modifier mask used for intent.

Glib::ustring Gtk::Widget::get_name | ( |  | ) | const

Retrieves the name of a widget.

See set_name() for the significance of widget names.

Returns:
  Name of the widget. This string is owned by GTK+ and should not be modified or freed.

Reimplemented from Gtk::Buildable.

bool Gtk::Widget::get_no_show_all | ( |  | ) | const

Returns the current value of the Gtk::Widget::property_no_show_all() property, which determines whether calls to show_all() will affect this widget.

Since gtkmm 2.4:

Returns:
  The current value of the "no-show-all" property.

Glib::RefPtr<Pango::Context> Gtk::Widget::get_pango_context | ( |  | ) |

Gets a Pango::Context with the appropriate font map, font description, and base direction for this widget.

Unlike the context returned by create_pango_context(), this context is owned by the widget (it can be used until the screen for the widget changes or the widget is removed from its toplevel), and will be updated to match any changes to the widget's attributes.

If you create and keep a Pango::Layout using this context, you must deal with changes to the context by calling pango_layout_context_changed() on the layout in response to the Gtk::Widget::signal_style_updated() and Gtk::Widget::signal_direction_changed() signals for the widget.

Returns:
  The Pango::Context for the widget.

Container* Gtk::Widget::get_parent | ( |  | ) |

Returns the parent container of widget.

Returns:
  The parent container of widget, or `0`.

const Container* Gtk::Widget::get_parent | ( |  | ) | const

Returns the parent container of widget.

Returns:
  The parent container of widget, or `0`.

Glib::RefPtr<Gdk::Window> Gtk::Widget::get_parent_window | ( |  | ) |

Gets widget's parent window.

Returns:
  The parent window of widget.

Glib::RefPtr<const Gdk::Window> Gtk::Widget::get_parent_window | ( |  | ) | const

Gets widget's parent window.

Returns:
  The parent window of widget.

WidgetPath Gtk::Widget::get_path | ( |  | ) | const

Returns the Gtk::WidgetPath representing widget, if the widget is not connected to a toplevel widget, a partial path will be created.

Returns:
  The Gtk::WidgetPath representing widget.

void Gtk::Widget::get_pointer | ( | int & | x,
|  | int & | y
| ) |  | const

Obtains the location of the mouse pointer in widget coordinates.

Widget coordinates are a bit odd; for historical reasons, they are defined as widget->window coordinates for widgets that are not Gtk::NO_WINDOW widgets, and are relative to widget->allocation.x, widget->allocation.y for widgets that are Gtk::NO_WINDOW widgets.

Deprecated: 3.4: Use gdk_window_get_device_position() instead.

Deprecated:
  Use Gdk::Window::get_device_position instead.

Parameters:

  x | Return location for the X coordinate, or `0`.
  y | Return location for the Y coordinate, or `0`.

void Gtk::Widget::get_preferred_height | ( | int & | minimum_height,
|  | int & | natural_height
| ) |  | const

Retrieves a widget's initial minimum and natural height.

<note>This call is specific to width-for-height requests.</note>

The returned request will be modified by the GtkWidgetClass::adjust_size_request virtual method and by any Gtk::SizeGroups that have been applied. That is, the returned request is the one that should be used for layout, not necessarily the one returned by the widget itself.

Since gtkmm 3.0:

Parameters:

  minimum_height | Location to store the minimum height, or `0`.
  natural_height | Location to store the natural height, or `0`.

void Gtk::Widget::get_preferred_height_for_width | ( | int | width,
|  | int & | minimum_height,
|  | int & | natural_height
| ) |  | const

Retrieves a widget's minimum and natural height if it would be given the specified width.

The returned request will be modified by the GtkWidgetClass::adjust_size_request virtual method and by any Gtk::SizeGroups that have been applied. That is, the returned request is the one that should be used for layout, not necessarily the one returned by the widget itself.

Since gtkmm 3.0:

Parameters:

  width | The width which is available for allocation.
  minimum_height | Location for storing the minimum height, or `0`.
  natural_height | Location for storing the natural height, or `0`.

virtual void Gtk::Widget::get_preferred_height_for_width_vfunc | ( | int | width,
|  | int & | minimum_height,
|  | int & | natural_height
| ) |  | const`[protected, virtual]`

virtual void Gtk::Widget::get_preferred_height_vfunc | ( | int & | minimum_height,
|  | int & | natural_height
| ) |  | const`[protected, virtual]`

void Gtk::Widget::get_preferred_size | ( | Requisition& | minimum_size,
|  | Requisition& | natural_size
| ) |  | const

Retrieves the minimum and natural size of a widget, taking into account the widget's preference for height-for-width management.

This is used to retrieve a suitable size by container widgets which do not impose any restrictions on the child placement. It can be used to deduce toplevel window and menu sizes as well as child widgets in free-form containers such as GtkLayout.

<note>Handle with care. Note that the natural height of a height-for-width widget will generally be a smaller size than the minimum height, since the required height for the natural width is generally smaller than the required height for the minimum width.</note>

Since gtkmm 3.0:

Parameters:

  minimum_size | Location for storing the minimum size, or `0`.
  natural_size | Location for storing the natural size, or `0`.

void Gtk::Widget::get_preferred_width | ( | int & | minimum_width,
|  | int & | natural_width
| ) |  | const

Retrieves a widget's initial minimum and natural width.

<note>This call is specific to height-for-width requests.</note>

The returned request will be modified by the GtkWidgetClass::adjust_size_request virtual method and by any Gtk::SizeGroups that have been applied. That is, the returned request is the one that should be used for layout, not necessarily the one returned by the widget itself.

Since gtkmm 3.0:

Parameters:

  minimum_width | Location to store the minimum width, or `0`.
  natural_width | Location to store the natural width, or `0`.

void Gtk::Widget::get_preferred_width_for_height | ( | int | height,
|  | int & | minimum_width,
|  | int & | natural_width
| ) |  | const

Retrieves a widget's minimum and natural width if it would be given the specified height.

The returned request will be modified by the GtkWidgetClass::adjust_size_request virtual method and by any Gtk::SizeGroups that have been applied. That is, the returned request is the one that should be used for layout, not necessarily the one returned by the widget itself.

Since gtkmm 3.0:

Parameters:

  height | The height which is available for allocation.
  minimum_width | Location for storing the minimum width, or `0`.
  natural_width | Location for storing the natural width, or `0`.

virtual void Gtk::Widget::get_preferred_width_for_height_vfunc | ( | int | height,
|  | int & | minimum_width,
|  | int & | natural_width
| ) |  | const`[protected, virtual]`

virtual void Gtk::Widget::get_preferred_width_vfunc | ( | int & | minimum_width,
|  | int & | natural_width
| ) |  | const`[protected, virtual]`

bool Gtk::Widget::get_realized | ( |  | ) | const

Determines whether widget is realized.

Since gtkmm 2.20:

Returns:
  `true` if widget is realized, `false` otherwise.

bool Gtk::Widget::get_receives_default | ( |  | ) | const

Determines whether widget is alyways treated as default widget withing its toplevel when it has the focus, even if another widget is the default.

See set_receives_default().

Since gtkmm 2.18:

Returns:
  `true` if widget acts as default widget when focussed, `false` otherwise.

SizeRequestMode Gtk::Widget::get_request_mode | ( |  | ) | const

Gets whether the widget prefers a height-for-width layout or a width-for-height layout.

<note>Gtk::Bin widgets generally propagate the preference of their child, container widgets need to request something either in context of their children or in context of their allocation capabilities.</note>

Since gtkmm 3.0:

Returns:
  The Gtk::SizeRequestMode preferred by widget.

virtual SizeRequestMode Gtk::Widget::get_request_mode_vfunc | ( |  | ) | const`[protected, virtual]`

Requisition Gtk::Widget::get_requisition | ( |  | ) | const`[protected]`

Retrieves the widget's requisition.

This method should only be used by widget implementations in order to discover whether the widget's requisition has actually changed after some internal state change (so that they can call queue_resize() instead of queue_draw()).

Normally, size_request() should be used.

Returns:
  The widget's requisition.

@newin{2,20}

Glib::RefPtr<Gdk::Window> Gtk::Widget::get_root_window | ( |  | ) |

Get the root window where this widget is located.

This function can only be called after the widget has been added to a widget hierarchy with Gtk::Window at the top.

The root window is useful for such purposes as creating a popup Gdk::Window associated with the window. In general, you should only create display specific resources when a widget has been realized, and you should free those resources when the widget is unrealized.

Since gtkmm 2.2:

Returns:
  The Gdk::Window root window for the toplevel for this widget.

Glib::RefPtr<const Gdk::Window> Gtk::Widget::get_root_window | ( |  | ) | const

Get the root window where this widget is located.

This function can only be called after the widget has been added to a widget hierarchy with Gtk::Window at the top.

The root window is useful for such purposes as creating a popup Gdk::Window associated with the window. In general, you should only create display specific resources when a widget has been realized, and you should free those resources when the widget is unrealized.

Since gtkmm 2.2:

Returns:
  The Gdk::Window root window for the toplevel for this widget.

Glib::RefPtr<Gdk::Screen> Gtk::Widget::get_screen | ( |  | ) |

Get the Gdk::Screen from the toplevel window associated with this widget.

This function can only be called after the widget has been added to a widget hierarchy with a Gtk::Window at the top.

In general, you should only create screen specific resources when a widget has been realized, and you should free those resources when the widget is unrealized.

Since gtkmm 2.2:

Returns:
  The Gdk::Screen for the toplevel for this widget.

Reimplemented in Gtk::Window, and Gtk::Invisible.

Glib::RefPtr<const Gdk::Screen> Gtk::Widget::get_screen | ( |  | ) | const

Get the Gdk::Screen from the toplevel window associated with this widget.

This function can only be called after the widget has been added to a widget hierarchy with a Gtk::Window at the top.

In general, you should only create screen specific resources when a widget has been realized, and you should free those resources when the widget is unrealized.

Since gtkmm 2.2:

Returns:
  The Gdk::Screen for the toplevel for this widget.

Reimplemented in Gtk::Window, and Gtk::Invisible.

bool Gtk::Widget::get_sensitive | ( |  | ) | const

Returns the widget's sensitivity (in the sense of returning the value that has been set using set_sensitive()).

The effective sensitivity of a widget is however determined by both its own and its parent widget's sensitivity. See is_sensitive().

Since gtkmm 2.18:

Returns:
  `true` if the widget is sensitive.

Glib::RefPtr<Settings> Gtk::Widget::get_settings | ( |  | ) |

Gets the settings object holding the settings used for this widget.

Note that this function can only be called when the Gtk::Widget is attached to a toplevel, since the settings object is specific to a particular Gdk::Screen.

Returns:
  The relevant Gtk::Settings object.

Reimplemented in Gtk::PrintUnixDialog.

void Gtk::Widget::get_size_request | ( | int & | width,
|  | int & | height
| ) |  | const

Gets the size request that was explicitly set for the widget using set_size_request().

A value of -1 stored in width or height indicates that that dimension has not been set explicitly and the natural requisition of the widget will be used intead. See set_size_request(). To get the size a widget will actually request, call get_preferred_size() instead of this function.

Parameters:

  width | Return location for width, or `0`.
  height | Return location for height, or `0`.

StateType Gtk::Widget::get_state | ( |  | ) | const

Returns the widget's state.

See set_state().

Since gtkmm 2.18:

Deprecated: 3.0. Use get_state_flags() instead.

Deprecated:
  Use get_state_flags() instead.

Returns:
  The state of widget.

StateFlags Gtk::Widget::get_state_flags | ( |  | ) | const

Returns the widget state as a flag set.

It is worth mentioning that the effective Gtk::STATE_FLAG_INSENSITIVE state will be returned, that is, also based on parent insensitivity, even if widget itself is sensitive.

Since gtkmm 3.0:

Returns:
  The state flags for widget.

Glib::RefPtr<StyleContext> Gtk::Widget::get_style_context | ( |  | ) |

Returns the style context associated to widget.

Returns:
  A Gtk::StyleContext. This memory is owned by widget and must not be freed.

Glib::RefPtr<Gtk::StyleContext> Gtk::Widget::get_style_context | ( |  | ) | const

Returns the style context associated to widget.

Returns:
  A Gtk::StyleContext. This memory is owned by widget and must not be freed.

template <class PropertyType >

void Gtk::Widget::get_style_property | ( | const Glib::ustring & | the_property_name,
|  | PropertyType & | value
| ) |  | const

void Gtk::Widget::get_style_property_value | ( | const Glib::ustring & | the_property_name,
|  | Glib::ValueBase & | value
| ) |  | const`[protected]`

Gets the value of a style property of widget.

Parameters:

  the_property_name | The name of a style property.
  value | Location to return the property value.

bool Gtk::Widget::get_support_multidevice | ( |  | ) | const

Returns `true` if widget is multiple pointer aware.

See set_support_multidevice() for more information.

Returns:
  `true` if widget is multidevice aware.

Glib::ustring Gtk::Widget::get_tooltip_markup | ( |  | ) | const

Gets the contents of the tooltip for widget.

Returns:
  The tooltip text.

Since gtkmm 2.12:

Glib::ustring Gtk::Widget::get_tooltip_text | ( |  | ) | const

Gets the contents of the tooltip for widget.

Returns:
  The tooltip text.

Since gtkmm 2.12:

Window* Gtk::Widget::get_tooltip_window | ( |  | ) |

Returns the Gtk::Window of the current tooltip.

This can be the GtkWindow created by default, or the custom tooltip window set using set_tooltip_window().

Since gtkmm 2.12:

Returns:
  The Gtk::Window of the current tooltip.

Container* Gtk::Widget::get_toplevel | ( |  | ) |

This function returns the topmost widget in the container hierarchy widget is a part of.

If widget has no parent widgets, it will be returned as the topmost widget. No reference will be added to the returned widget; it should not be unreferenced.

Note the difference in behavior vs. get_ancestor(); `gtk_widget_get_ancestor (widget, GTK_TYPE_WINDOW)` would return `0` if widget wasn't inside a toplevel window, and if the window was inside a Gtk::Window-derived widget which was in turn inside the toplevel Gtk::Window. While the second case may seem unlikely, it actually happens when a Gtk::Plug is embedded inside a Gtk::Socket within the same application.

To reliably find the toplevel Gtk::Window, use get_toplevel() and check if the T::OPLEVEL flags is set on the result.

[C example ellipted]

Returns:
  The topmost ancestor of widget, or widget itself if there's no ancestor.

const Container* Gtk::Widget::get_toplevel | ( |  | ) | const

This function returns the topmost widget in the container hierarchy widget is a part of.

If widget has no parent widgets, it will be returned as the topmost widget. No reference will be added to the returned widget; it should not be unreferenced.

Note the difference in behavior vs. get_ancestor(); `gtk_widget_get_ancestor (widget, GTK_TYPE_WINDOW)` would return `0` if widget wasn't inside a toplevel window, and if the window was inside a Gtk::Window-derived widget which was in turn inside the toplevel Gtk::Window. While the second case may seem unlikely, it actually happens when a Gtk::Plug is embedded inside a Gtk::Socket within the same application.

To reliably find the toplevel Gtk::Window, use get_toplevel() and check if the T::OPLEVEL flags is set on the result.

[C example ellipted]

Returns:
  The topmost ancestor of widget, or widget itself if there's no ancestor.

Align Gtk::Widget::get_valign | ( |  | ) | const

Gets the value of the Gtk::Widget::property_valign() property.

Returns:
  The vertical alignment of widget.

bool Gtk::Widget::get_vexpand | ( |  | ) | const

Gets whether the widget would like any available extra vertical space.

See get_hexpand() for more detail.

Returns:
  Whether vexpand flag is set.

bool Gtk::Widget::get_vexpand_set | ( |  | ) | const

Gets whether set_vexpand() has been used to explicitly set the expand flag on this widget.

See get_hexpand_set() for more detail.

Returns:
  Whether vexpand has been explicitly set.

bool Gtk::Widget::get_visible | ( |  | ) | const

Determines whether the widget is visible.

Note that this doesn't take into account whether the widget's parent is also visible or the widget is obscured in any way.

See set_visible().

Since gtkmm 2.18:

Returns:
  `true` if the widget is visible.

Glib::RefPtr<Gdk::Visual> Gtk::Widget::get_visual | ( |  | ) |

Gets the visual that will be used to render widget.

Returns:
  The visual for widget.

int Gtk::Widget::get_width | ( |  | ) | const

Glib::RefPtr<Gdk::Window> Gtk::Widget::get_window | ( |  | ) |

Returns the widget's window if it is realized, `0` otherwise.

Since gtkmm 2.14:

Returns:
  widget's window.

Glib::RefPtr<const Gdk::Window> Gtk::Widget::get_window | ( |  | ) | const

Returns the widget's window if it is realized, `0` otherwise.

Since gtkmm 2.14:

Returns:
  widget's window.

GtkWidget* Gtk::Widget::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GtkObject.

Reimplemented from Gtk::Buildable.

Reimplemented in Gtk::FontSelectionDialog, Gtk::ColorSelectionDialog, Gtk::TreeView, Gtk::HScale, Gtk::Window, Gtk::HScrollbar, Gtk::HBox, Gtk::HButtonBox, Gtk::Calendar, Gtk::HSeparator, Gtk::ToolPalette, Gtk::VPaned, Gtk::SpinButton, Gtk::Dialog, Gtk::TextView, Gtk::Image, Gtk::IconView, Gtk::AboutDialog, Gtk::Entry, Gtk::MessageDialog, Gtk::Box, Gtk::Socket, Gtk::Assistant, Gtk::MenuBar, Gtk::Notebook, Gtk::Table, Gtk::ComboBox, Gtk::Paned, Gtk::ProgressBar, Gtk::ButtonBox, Gtk::FontSelection, Gtk::VScrollbar, Gtk::Container, Gtk::Expander, Gtk::ColorSelection, Gtk::OffscreenWindow, Gtk::VScale, Gtk::Grid, Gtk::InfoBar, Gtk::VButtonBox, Gtk::FileChooserButton, Gtk::ScrolledWindow, Gtk::LinkButton, Gtk::Scrollbar, Gtk::PrintUnixDialog, Gtk::AppChooserDialog, Gtk::CellView, Gtk::HandleBox, Gtk::VSeparator, Gtk::RecentChooserDialog, Gtk::VBox, Gtk::Button, Gtk::Layout, Gtk::ScaleButton, Gtk::HPaned, Gtk::Alignment, Gtk::Arrow, Gtk::ColorButton, Gtk::Scale, Gtk::Toolbar, Gtk::AppChooserWidget, Gtk::Fixed, Gtk::FontButton, Gtk::Frame, Gtk::MenuItem, Gtk::RecentChooserMenu, Gtk::Statusbar, Gtk::MenuShell, Gtk::TearoffMenuItem, Gtk::AppChooserButton, Gtk::CheckButton, Gtk::EventBox, Gtk::FileChooserWidget, Gtk::FontChooserDialog, Gtk::FontChooserWidget, Gtk::Menu, Gtk::AspectFrame, Gtk::Label, Gtk::RadioButton, Gtk::RecentChooserWidget, Gtk::FileChooserDialog, Gtk::ImageMenuItem, Gtk::Misc, Gtk::Separator, Gtk::SeparatorToolItem, Gtk::ToolItem, Gtk::Bin, Gtk::ComboBoxText, Gtk::RadioToolButton, Gtk::ToggleToolButton, Gtk::ToolItemGroup, Gtk::VolumeButton, Gtk::RadioMenuItem, Gtk::Switch, Gtk::PageSetupUnixDialog, Gtk::ColorChooserDialog, Gtk::Viewport, Gtk::CheckMenuItem, Gtk::MenuToolButton, Gtk::Range, Gtk::SeparatorMenuItem, Gtk::ToggleButton, Gtk::AccelLabel, Gtk::ApplicationWindow, Gtk::DrawingArea, Gtk::Invisible, Gtk::Spinner, Gtk::Plug, and Gtk::ToolButton.

const GtkWidget* Gtk::Widget::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GtkObject.

Reimplemented from Gtk::Buildable.

Reimplemented in Gtk::FontSelectionDialog, Gtk::ColorSelectionDialog, Gtk::TreeView, Gtk::HScale, Gtk::Window, Gtk::HScrollbar, Gtk::HBox, Gtk::HButtonBox, Gtk::Calendar, Gtk::HSeparator, Gtk::ToolPalette, Gtk::VPaned, Gtk::SpinButton, Gtk::Dialog, Gtk::TextView, Gtk::Image, Gtk::IconView, Gtk::AboutDialog, Gtk::Entry, Gtk::MessageDialog, Gtk::Box, Gtk::Socket, Gtk::Assistant, Gtk::MenuBar, Gtk::Notebook, Gtk::Table, Gtk::ComboBox, Gtk::Paned, Gtk::ProgressBar, Gtk::ButtonBox, Gtk::FontSelection, Gtk::VScrollbar, Gtk::Container, Gtk::Expander, Gtk::ColorSelection, Gtk::OffscreenWindow, Gtk::VScale, Gtk::Grid, Gtk::InfoBar, Gtk::VButtonBox, Gtk::FileChooserButton, Gtk::ScrolledWindow, Gtk::LinkButton, Gtk::Scrollbar, Gtk::PrintUnixDialog, Gtk::AppChooserDialog, Gtk::CellView, Gtk::HandleBox, Gtk::VSeparator, Gtk::RecentChooserDialog, Gtk::VBox, Gtk::Button, Gtk::Layout, Gtk::ScaleButton, Gtk::HPaned, Gtk::Alignment, Gtk::Arrow, Gtk::ColorButton, Gtk::Scale, Gtk::Toolbar, Gtk::AppChooserWidget, Gtk::Fixed, Gtk::FontButton, Gtk::Frame, Gtk::MenuItem, Gtk::RecentChooserMenu, Gtk::Statusbar, Gtk::MenuShell, Gtk::TearoffMenuItem, Gtk::AppChooserButton, Gtk::CheckButton, Gtk::EventBox, Gtk::FileChooserWidget, Gtk::FontChooserDialog, Gtk::FontChooserWidget, Gtk::Menu, Gtk::AspectFrame, Gtk::Label, Gtk::RadioButton, Gtk::RecentChooserWidget, Gtk::FileChooserDialog, Gtk::ImageMenuItem, Gtk::Misc, Gtk::Separator, Gtk::SeparatorToolItem, Gtk::ToolItem, Gtk::Bin, Gtk::ComboBoxText, Gtk::RadioToolButton, Gtk::ToggleToolButton, Gtk::ToolItemGroup, Gtk::VolumeButton, Gtk::RadioMenuItem, Gtk::Switch, Gtk::PageSetupUnixDialog, Gtk::ColorChooserDialog, Gtk::Viewport, Gtk::CheckMenuItem, Gtk::MenuToolButton, Gtk::Range, Gtk::SeparatorMenuItem, Gtk::ToggleButton, Gtk::AccelLabel, Gtk::ApplicationWindow, Gtk::DrawingArea, Gtk::Invisible, Gtk::Spinner, Gtk::Plug, and Gtk::ToolButton.

void Gtk::Widget::grab_default | ( |  | ) |

Causes widget to become the default widget.

widget must have the Gtk::CAN_DEFAULT flag set; typically you have to set this flag yourself by calling `gtk_widget_set_can_default ( widget, `true`)`. The default widget is activated when the user presses Enter in a window. Default widgets must be activatable, that is, activate() should affect them. Note that Gtk::Entry widgets require the "activates-default" property set to `true` before they activate the default widget when Enter is pressed and the Gtk::Entry is focused.

void Gtk::Widget::grab_focus | ( |  | ) |

Causes widget to have the keyboard focus for the Gtk::Window it's inside.

widget must be a focusable widget, such as a Gtk::Entry; something like Gtk::Frame won't work.

More precisely, it must have the Gtk::CAN_FOCUS flag set. Use set_can_focus() to modify that flag.

The widget also needs to be realized and mapped. This is indicated by the related signals. Grabbing the focus immediately after creating the widget will likely fail and cause critical warnings.

bool Gtk::Widget::has_default | ( |  | ) | const

Determines whether widget is the current default widget within its toplevel.

See set_can_default().

Since gtkmm 2.18:

Returns:
  `true` if widget is the current default widget within its toplevel, `false` otherwise.

bool Gtk::Widget::has_focus | ( |  | ) | const

Determines if the widget has the global input focus.

See is_focus() for the difference between having the global input focus, and only having the focus within a toplevel.

Since gtkmm 2.18:

Returns:
  `true` if the widget has the global input focus.

bool Gtk::Widget::has_grab | ( |  | ) | const

Determines whether the widget is currently grabbing events, so it is the only widget receiving input events (keyboard and mouse).

See also gtk_grab_add().

Since gtkmm 2.18:

Returns:
  `true` if the widget is in the grab_widgets stack.

bool Gtk::Widget::has_screen | ( |  | ) | const

Checks whether there is a Gdk::Screen is associated with this widget.

All toplevel widgets have an associated screen, and all widgets added into a hierarchy with a toplevel window at the top.

Since gtkmm 2.2:

Returns:
  `true` if there is a Gdk::Screen associcated with the widget.

void Gtk::Widget::hide | ( |  | ) |

Reverses the effects of show(), causing the widget to be hidden (invisible to the user).

bool Gtk::Widget::in_destruction | ( |  | ) | const

Returns whether the widget is currently being destroyed.

This information can sometimes be used to avoid doing unnecessary work.

Returns:
  `true` if widget is being destroyed.

void Gtk::Widget::input_shape_combine_region | ( | const ::Cairo::RefPtr< const ::Cairo::Region > & | region | ) |

Sets an input shape for this widget's GDK window.

This allows for windows which react to mouse click in a nonrectangular region, see gdk_window_input_shape_combine_region() for more information.

Since gtkmm 3.0:

Parameters:

  region | Shape to be added, or `0` to remove an existing shape.

bool Gtk::Widget::intersect | ( | const Gdk::Rectangle& | area | ) | const

bool Gtk::Widget::intersect | ( | const Gdk::Rectangle& | area,
|  | Gdk::Rectangle& | intersection
| ) |  | const

Computes the intersection of a widget's area and area, storing the intersection in intersection, and returns `true` if there was an intersection.

intersection may be `0` if you're only interested in whether there was an intersection.

Parameters:

  area | A rectangle.
  intersection | Rectangle to store intersection of widget and area.

Returns:
  `true` if there was an intersection.

bool Gtk::Widget::is_ancestor | ( | Widget& | ancestor | ) | const

Determines whether widget is somewhere inside ancestor, possibly with intermediate containers.

Parameters:

  ancestor | Another Gtk::Widget.

Returns:
  `true` if ancestor contains widget as a child, grandchild, great grandchild, etc.

bool Gtk::Widget::is_composited | ( |  | ) | const

Whether widget can rely on having its alpha channel drawn correctly.

On X11 this function returns whether a compositing manager is running for widget's screen.

Please note that the semantics of this call will change in the future if used on a widget that has a composited window in its hierarchy (as set by gdk_window_set_composited()).

Since gtkmm 2.10:

Returns:
  `true` if the widget can rely on its alpha channel being drawn correctly.

bool Gtk::Widget::is_focus | ( |  | ) | const

Determines if the widget is the focus widget within its toplevel.

(This does not mean that the HAS_FOCUS flag is necessarily set; HAS_FOCUS will only be set if the toplevel widget additionally has the global input focus.)

Returns:
  `true` if the widget is the focus widget.

bool Gtk::Widget::is_sensitive | ( |  | ) | const

Returns the widget's effective sensitivity, which means it is sensitive itself and also its parent widget is sensitive.

Since gtkmm 2.18:

Returns:
  `true` if the widget is effectively sensitive.

bool Gtk::Widget::keynav_failed | ( | DirectionType | direction | ) |

This function should be called whenever keyboard navigation within a single widget hits a boundary.

The function emits the Gtk::Widget::signal_keynav_failed() signal on the widget and its return value should be interpreted in a way similar to the return value of child_focus():

When `true` is returned, stay in the widget, the failed keyboard navigation is Ok and/or there is nowhere we can/should move the focus to.

When `false` is returned, the caller should continue with keyboard navigation outside the widget, e.g. by calling child_focus() on the widget's toplevel.

The default signal_keynav_failed() handler returns `true` for Gtk::DIR_TAB_FORWARD and Gtk::DIR_TAB_BACKWARD. For the other values of Gtk::DirectionType, it looks at the Gtk::Settings::property_gtk_keynav_cursor_only() setting and returns `false` if the setting is `true`. This way the entire user interface becomes cursor-navigatable on input devices such as mobile phones which only have cursor keys but no tab key.

Whenever the default handler returns `true`, it also calls error_bell() to notify the user of the failed keyboard navigation.

A use case for providing an own implementation of signal_keynav_failed() (either by connecting to it or by overriding it) would be a row of Gtk::Entry widgets where the user should be able to navigate the entire row with the cursor keys, as e.g. known from user interfaces that require entering license keys.

Since gtkmm 2.12:

Parameters:

  direction | Direction of focus movement.

Returns:
  `true` if stopping keyboard navigation is fine, `false` if the emitting widget should try to handle the keyboard navigation attempt in its parent container(s).

std::vector<Widget*> Gtk::Widget::list_mnemonic_labels | ( |  | ) |

Returns a newly allocated list of the widgets, normally labels, for which this widget is the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()).

The widgets in the list are not individually referenced. If you want to iterate through the list and perform actions involving callbacks that might destroy the widgets, you must call `g_list_foreach (result, (GFunc)g_object_ref, `0`)` first, and then unref all the widgets afterwards.

Since gtkmm 2.4:

Returns:
  The list of mnemonic labels; free this list with Glib::list_free() when you are done with it.

std::vector<const Widget*> Gtk::Widget::list_mnemonic_labels | ( |  | ) | const

Returns a newly allocated list of the widgets, normally labels, for which this widget is the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()).

The widgets in the list are not individually referenced. If you want to iterate through the list and perform actions involving callbacks that might destroy the widgets, you must call `g_list_foreach (result, (GFunc)g_object_ref, `0`)` first, and then unref all the widgets afterwards.

Since gtkmm 2.4:

Returns:
  The list of mnemonic labels; free this list with Glib::list_free() when you are done with it.

void Gtk::Widget::map | ( |  | ) |

This function is only for use in widget implementations.

Causes a widget to be mapped if it isn't already.

bool Gtk::Widget::mnemonic_activate | ( | bool | group_cycling | ) |

Emits the Gtk::Widget::signal_mnemonic_activate() signal.

The default handler for this signal activates the widget if group_cycling is `false`, and just grabs the focus if group_cycling is `true`.

Parameters:

  group_cycling | `true` if there are other widgets with the same mnemonic.

Returns:
  `true` if the signal has been handled.

virtual bool Gtk::Widget::on_button_press_event | ( | GdkEventButton * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_button_press_event().

virtual bool Gtk::Widget::on_button_release_event | ( | GdkEventButton * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_button_release_event().

virtual void Gtk::Widget::on_child_notify | ( | GParamSpec * | pspec | ) | `[protected, virtual]`

This is a default handler for the signal signal_child_notify().

virtual bool Gtk::Widget::on_configure_event | ( | GdkEventConfigure * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_configure_event().

virtual bool Gtk::Widget::on_delete_event | ( | GdkEventAny * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_delete_event().

virtual void Gtk::Widget::on_direction_changed | ( | TextDirection | direction | ) | `[protected, virtual]`

This is a default handler for the signal signal_direction_changed().

virtual void Gtk::Widget::on_drag_begin | ( | const Glib::RefPtr< Gdk::DragContext >& | context | ) | `[protected, virtual]`

This is a default handler for the signal signal_drag_begin().

virtual void Gtk::Widget::on_drag_data_delete | ( | const Glib::RefPtr< Gdk::DragContext >& | context | ) | `[protected, virtual]`

This is a default handler for the signal signal_drag_data_delete().

virtual void Gtk::Widget::on_drag_data_get | ( | const Glib::RefPtr< Gdk::DragContext >& | context,
|  | SelectionData& | selection_data,
|  | guint | info,
|  | guint | time
| ) |  | `[protected, virtual]`

This is a default handler for the signal signal_drag_data_get().

virtual void Gtk::Widget::on_drag_data_received | ( | const Glib::RefPtr< Gdk::DragContext >& | context,
|  | int | x,
|  | int | y,
|  | const SelectionData& | selection_data,
|  | guint | info,
|  | guint | time
| ) |  | `[protected, virtual]`

This is a default handler for the signal signal_drag_data_received().

virtual bool Gtk::Widget::on_drag_drop | ( | const Glib::RefPtr< Gdk::DragContext >& | context,
|  | int | x,
|  | int | y,
|  | guint | time
| ) |  | `[protected, virtual]`

This is a default handler for the signal signal_drag_drop().

virtual void Gtk::Widget::on_drag_end | ( | const Glib::RefPtr< Gdk::DragContext >& | context | ) | `[protected, virtual]`

This is a default handler for the signal signal_drag_end().

virtual void Gtk::Widget::on_drag_leave | ( | const Glib::RefPtr< Gdk::DragContext >& | context,
|  | guint | time
| ) |  | `[protected, virtual]`

This is a default handler for the signal signal_drag_leave().

virtual bool Gtk::Widget::on_drag_motion | ( | const Glib::RefPtr< Gdk::DragContext >& | context,
|  | int | x,
|  | int | y,
|  | guint | time
| ) |  | `[protected, virtual]`

This is a default handler for the signal signal_drag_motion().

virtual bool Gtk::Widget::on_draw | ( | const ::Cairo::RefPtr< ::Cairo::Context > & | cr | ) | `[protected, virtual]`

This is a default handler for the signal signal_draw().

virtual bool Gtk::Widget::on_enter_notify_event | ( | GdkEventCrossing * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_enter_notify_event().

virtual bool Gtk::Widget::on_event | ( | GdkEvent * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_event().

virtual bool Gtk::Widget::on_focus | ( | DirectionType | direction | ) | `[protected, virtual]`

This is a default handler for the signal signal_focus().

virtual bool Gtk::Widget::on_focus_in_event | ( | GdkEventFocus * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_focus_in_event().

virtual bool Gtk::Widget::on_focus_out_event | ( | GdkEventFocus * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_focus_out_event().

virtual void Gtk::Widget::on_grab_focus | ( |  | ) | `[protected, virtual]`

This is a default handler for the signal signal_grab_focus().

virtual void Gtk::Widget::on_grab_notify | ( | bool | was_grabbed | ) | `[protected, virtual]`

This is a default handler for the signal signal_grab_notify().

virtual void Gtk::Widget::on_hide | ( |  | ) | `[protected, virtual]`

This is a default handler for the signal signal_hide().

virtual void Gtk::Widget::on_hierarchy_changed | ( | Widget* | previous_toplevel | ) | `[protected, virtual]`

This is a default handler for the signal signal_hierarchy_changed().

virtual bool Gtk::Widget::on_key_press_event | ( | GdkEventKey * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_key_press_event().

virtual bool Gtk::Widget::on_key_release_event | ( | GdkEventKey * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_key_release_event().

virtual bool Gtk::Widget::on_leave_notify_event | ( | GdkEventCrossing * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_leave_notify_event().

virtual void Gtk::Widget::on_map | ( |  | ) | `[protected, virtual]`

This is a default handler for the signal signal_map().

virtual bool Gtk::Widget::on_map_event | ( | GdkEventAny * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_map_event().

virtual bool Gtk::Widget::on_mnemonic_activate | ( | bool | group_cycling | ) | `[protected, virtual]`

This is a default handler for the signal signal_mnemonic_activate().

virtual bool Gtk::Widget::on_motion_notify_event | ( | GdkEventMotion * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_motion_notify_event().

virtual void Gtk::Widget::on_parent_changed | ( | Widget* | previous_parent | ) | `[protected, virtual]`

This is a default handler for the signal signal_parent_changed().

virtual bool Gtk::Widget::on_property_notify_event | ( | GdkEventProperty * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_property_notify_event().

virtual bool Gtk::Widget::on_proximity_in_event | ( | GdkEventProximity * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_proximity_in_event().

virtual bool Gtk::Widget::on_proximity_out_event | ( | GdkEventProximity * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_proximity_out_event().

virtual void Gtk::Widget::on_realize | ( |  | ) | `[protected, virtual]`

This is a default handler for the signal signal_realize().

virtual void Gtk::Widget::on_screen_changed | ( | const Glib::RefPtr< Gdk::Screen >& | previous_screen | ) | `[protected, virtual]`

This is a default handler for the signal signal_screen_changed().

virtual bool Gtk::Widget::on_scroll_event | ( | GdkEventScroll * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_scroll_event().

virtual bool Gtk::Widget::on_selection_clear_event | ( | GdkEventSelection * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_selection_clear_event().

virtual void Gtk::Widget::on_selection_get | ( | SelectionData& | selection_data,
|  | guint | info,
|  | guint | time
| ) |  | `[protected, virtual]`

This is a default handler for the signal signal_selection_get().

virtual bool Gtk::Widget::on_selection_notify_event | ( | GdkEventSelection * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_selection_notify_event().

virtual void Gtk::Widget::on_selection_received | ( | const SelectionData& | selection_data,
|  | guint | time
| ) |  | `[protected, virtual]`

This is a default handler for the signal signal_selection_received().

virtual bool Gtk::Widget::on_selection_request_event | ( | GdkEventSelection * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_selection_request_event().

virtual void Gtk::Widget::on_show | ( |  | ) | `[protected, virtual]`

This is a default handler for the signal signal_show().

virtual void Gtk::Widget::on_size_allocate | ( | Allocation& | allocation | ) | `[protected, virtual]`

This is a default handler for the signal signal_size_allocate().

virtual void Gtk::Widget::on_state_changed | ( | Gtk::StateType | previous_state | ) | `[protected, virtual]`

This is a default handler for the signal signal_state_changed().

virtual void Gtk::Widget::on_style_updated | ( |  | ) | `[protected, virtual]`

This is a default handler for the signal signal_style_updated().

virtual void Gtk::Widget::on_unmap | ( |  | ) | `[protected, virtual]`

This is a default handler for the signal signal_unmap().

virtual bool Gtk::Widget::on_unmap_event | ( | GdkEventAny * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_unmap_event().

virtual void Gtk::Widget::on_unrealize | ( |  | ) | `[protected, virtual]`

This is a default handler for the signal signal_unrealize().

virtual bool Gtk::Widget::on_visibility_notify_event | ( | GdkEventVisibility * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_visibility_notify_event().

virtual bool Gtk::Widget::on_window_state_event | ( | GdkEventWindowState * | event | ) | `[protected, virtual]`

This is a default handler for the signal signal_window_state_event().

void Gtk::Widget::override_background_color | ( | const Gdk::RGBA& | color,
|  | StateFlags | state = `(StateFlags) 0`
| ) |  |

void Gtk::Widget::override_color | ( | const Gdk::RGBA& | color,
|  | StateFlags | state = `(StateFlags) 0`
| ) |  |

void Gtk::Widget::override_cursor | ( | const Gdk::RGBA& | cursor,
|  | const Gdk::RGBA& | secondary_cursor
| ) |  |

Sets the cursor color to use in a widget, overriding the Gtk::Widget::property_cursor_color() and Gtk::Widget::property_secondary_cursor_color() style properties.

All other style values are left untouched. See also modify_style().

Note that the underlying properties have the Gdk::Color type, so the alpha value in primary and secondary will be ignored.

Since gtkmm 3.0:

Parameters:

  cursor | The color to use for primary cursor (does not need to be allocated), or `0` to undo the effect of previous calls to of override_cursor().
  secondary_cursor | The color to use for secondary cursor (does not need to be allocated), or `0` to undo the effect of previous calls to of override_cursor().

void Gtk::Widget::override_font | ( | const Pango::FontDescription & | font_desc | ) |

Sets the font to use for a widget.

All other style values are left untouched. See override_color().

Since gtkmm 3.0:

Parameters:

  font_desc | The font descriptiong to use, or `0` to undo the effect of previous calls to override_font().

void Gtk::Widget::override_symbolic_color | ( | const Glib::ustring & | name,
|  | const Gdk::RGBA& | color
| ) |  |

Sets a symbolic color for a widget.

All other style values are left untouched. See override_color() for overriding the foreground or background color.

Since gtkmm 3.0:

Parameters:

  name | The name of the symbolic color to modify.
  color | The color to assign (does not need to be allocated), or `0` to undo the effect of previous calls to override_symbolic_color().

static void Gtk::Widget::pop_composite_child | ( |  | ) | `[static]`

Cancels the effect of a previous call to push_composite_child().

Glib::PropertyProxy< bool > Gtk::Widget::property_app_paintable | ( |  | ) |

Whether the application will paint directly on the widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_app_paintable | ( |  | ) | const

Whether the application will paint directly on the widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Widget::property_can_default | ( |  | ) |

Whether the widget can be the default widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_can_default | ( |  | ) | const

Whether the widget can be the default widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Widget::property_can_focus | ( |  | ) |

Whether the widget can accept the input focus.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_can_focus | ( |  | ) | const

Whether the widget can accept the input focus.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_composite_child | ( |  | ) | const

Whether the widget is part of a composite widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Widget::property_double_buffered | ( |  | ) |

Whether the widget is double buffered.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_double_buffered | ( |  | ) | const

Whether the widget is double buffered.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< Gdk::EventMask > Gtk::Widget::property_events | ( |  | ) |

The event mask that decides what kind of GdkEvents this widget gets.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Gdk::EventMask > Gtk::Widget::property_events | ( |  | ) | const

The event mask that decides what kind of GdkEvents this widget gets.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Widget::property_expand | ( |  | ) |

Whether widget wants to expand in both directions.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_expand | ( |  | ) | const

Whether widget wants to expand in both directions.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< Align > Gtk::Widget::property_halign | ( |  | ) |

How to position in extra horizontal space.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Align > Gtk::Widget::property_halign | ( |  | ) | const

How to position in extra horizontal space.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Widget::property_has_default | ( |  | ) |

Whether the widget is the default widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_has_default | ( |  | ) | const

Whether the widget is the default widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Widget::property_has_focus | ( |  | ) |

Whether the widget has the input focus.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_has_focus | ( |  | ) | const

Whether the widget has the input focus.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Widget::property_has_tooltip | ( |  | ) |

Whether this widget has a tooltip.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_has_tooltip | ( |  | ) | const

Whether this widget has a tooltip.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< int > Gtk::Widget::property_height_request | ( |  | ) |

Override for height request of the widget, or -1 if natural request should be used.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< int > Gtk::Widget::property_height_request | ( |  | ) | const

Override for height request of the widget, or -1 if natural request should be used.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Widget::property_hexpand | ( |  | ) |

Whether widget wants more horizontal space.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_hexpand | ( |  | ) | const

Whether widget wants more horizontal space.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Widget::property_hexpand_set | ( |  | ) |

Whether to use the hexpand property.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_hexpand_set | ( |  | ) | const

Whether to use the hexpand property.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Widget::property_is_focus | ( |  | ) |

Whether the widget is the focus widget within the toplevel.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_is_focus | ( |  | ) | const

Whether the widget is the focus widget within the toplevel.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< int > Gtk::Widget::property_margin | ( |  | ) |

Pixels of extra space on all four sides.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Reimplemented in Gtk::IconView.

Glib::PropertyProxy_ReadOnly< int > Gtk::Widget::property_margin | ( |  | ) | const

Pixels of extra space on all four sides.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Reimplemented in Gtk::IconView.

Glib::PropertyProxy< int > Gtk::Widget::property_margin_bottom | ( |  | ) |

Pixels of extra space on the bottom side.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< int > Gtk::Widget::property_margin_bottom | ( |  | ) | const

Pixels of extra space on the bottom side.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< int > Gtk::Widget::property_margin_left | ( |  | ) |

Pixels of extra space on the left side.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< int > Gtk::Widget::property_margin_left | ( |  | ) | const

Pixels of extra space on the left side.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< int > Gtk::Widget::property_margin_right | ( |  | ) |

Pixels of extra space on the right side.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< int > Gtk::Widget::property_margin_right | ( |  | ) | const

Pixels of extra space on the right side.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< int > Gtk::Widget::property_margin_top | ( |  | ) |

Pixels of extra space on the top side.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< int > Gtk::Widget::property_margin_top | ( |  | ) | const

Pixels of extra space on the top side.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::ustring > Gtk::Widget::property_name | ( |  | ) |

The name of the widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Widget::property_name | ( |  | ) | const

The name of the widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Widget::property_no_show_all | ( |  | ) |

Whether gtk_widget_show_all() should not affect this widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_no_show_all | ( |  | ) | const

Whether gtk_widget_show_all() should not affect this widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< Container* > Gtk::Widget::property_parent | ( |  | ) |

The parent widget of this widget.

Must be a Container widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Container* > Gtk::Widget::property_parent | ( |  | ) | const

The parent widget of this widget.

Must be a Container widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Widget::property_receives_default | ( |  | ) |

If TRUE, the widget will receive the default action when it is focused.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_receives_default | ( |  | ) | const

If TRUE, the widget will receive the default action when it is focused.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Widget::property_sensitive | ( |  | ) |

Whether the widget responds to input.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_sensitive | ( |  | ) | const

Whether the widget responds to input.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::RefPtr<Style> > Gtk::Widget::property_style | ( |  | ) |

The style of the widget, which contains information about how it will look (colors etc).

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Style> > Gtk::Widget::property_style | ( |  | ) | const

The style of the widget, which contains information about how it will look (colors etc).

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::ustring > Gtk::Widget::property_tooltip_markup | ( |  | ) |

The contents of the tooltip for this widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Widget::property_tooltip_markup | ( |  | ) | const

The contents of the tooltip for this widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::ustring > Gtk::Widget::property_tooltip_text | ( |  | ) |

The contents of the tooltip for this widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Widget::property_tooltip_text | ( |  | ) | const

The contents of the tooltip for this widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< Align > Gtk::Widget::property_valign | ( |  | ) |

How to position in extra vertical space.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Align > Gtk::Widget::property_valign | ( |  | ) | const

How to position in extra vertical space.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Widget::property_vexpand | ( |  | ) |

Whether widget wants more vertical space.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_vexpand | ( |  | ) | const

Whether widget wants more vertical space.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Widget::property_vexpand_set | ( |  | ) |

Whether to use the vexpand property.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_vexpand_set | ( |  | ) | const

Whether to use the vexpand property.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Widget::property_visible | ( |  | ) |

Whether the widget is visible.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Widget::property_visible | ( |  | ) | const

Whether the widget is visible.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< int > Gtk::Widget::property_width_request | ( |  | ) |

Override for width request of the widget, or -1 if natural request should be used.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< int > Gtk::Widget::property_width_request | ( |  | ) | const

Override for width request of the widget, or -1 if natural request should be used.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gdk::Window> > Gtk::Widget::property_window | ( |  | ) | const

The widget's window if it is realized.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

static void Gtk::Widget::push_composite_child | ( |  | ) | `[static]`

Makes all newly-created widgets as composite children until the corresponding pop_composite_child() call.

A composite child is a child that's an implementation detail of the container it's inside and should not be visible to people using the container. Composite children aren't treated differently by GTK (but see Gtk::Container::foreach() vs. Gtk::Container::forall()), but e.g. GUI builders might want to treat them in a different way.

Here is a simple example:

[C example ellipted]

void Gtk::Widget::queue_compute_expand | ( |  | ) |

Mark widget as needing to recompute its expand flags.

Call this function when setting legacy expand child properties on the child of a container.

See compute_expand().

void Gtk::Widget::queue_draw | ( |  | ) |

Equivalent to calling queue_draw_area() for the entire area of a widget.

void Gtk::Widget::queue_draw_area | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height
| ) |  |

Convenience function that calls queue_draw_region() on the region created from the given coordinates.

The region here is specified in widget coordinates. Widget coordinates are a bit odd; for historical reasons, they are defined as widget->window coordinates for widgets that are not Gtk::NO_WINDOW widgets, and are relative to widget->allocation.x, widget->allocation.y for widgets that are Gtk::NO_WINDOW widgets.

Parameters:

  x | X coordinate of upper-left corner of rectangle to redraw.
  y | Y coordinate of upper-left corner of rectangle to redraw.
  width | Width of region to draw.
  height | Height of region to draw.

void Gtk::Widget::queue_draw_region | ( | const ::Cairo::RefPtr< const ::Cairo::Region > & | region | ) |

Invalidates the rectangular area of widget defined by region by calling gdk_window_invalidate_region() on the widget's window and all its child windows.

Once the main loop becomes idle (after the current batch of events has been processed, roughly), the window will receive expose events for the union of all regions that have been invalidated.

Normally you would only use this function in widget implementations. You might also use it to schedule a redraw of a Gtk::DrawingArea or some portion thereof.

Since gtkmm 3.0:

Parameters:

  region | Region to draw.

void Gtk::Widget::queue_resize | ( |  | ) |

This function is only for use in widget implementations.

Flags a widget to have its size renegotiated; should be called when a widget for some reason has a new size request. For example, when you change the text in a Gtk::Label, Gtk::Label queues a resize to ensure there's enough space for the new text.

<note>You cannot call queue_resize() on a widget from inside its implementation of the GtkWidgetClass::size_allocate virtual method. Calls to queue_resize() from inside GtkWidgetClass::size_allocate will be silently ignored.</note>

void Gtk::Widget::queue_resize_no_redraw | ( |  | ) |

This function works like queue_resize(), except that the widget is not invalidated.

Since gtkmm 2.4:

void Gtk::Widget::realize | ( |  | ) | `[protected]`

Creates the GDK (windowing system) resources associated with a widget.

For example, widget->window will be created when a widget is realized. Normally realization happens implicitly; if you show a widget and all its parent containers, then the widget will be realized and mapped automatically.

Realizing a widget requires all the widget's parent widgets to be realized; calling realize() realizes the widget's parents in addition to widget itself. If a widget is not yet inside a toplevel window when you realize it, bad things will happen.

This function is primarily used in widget implementations, and isn't very useful otherwise. Many times when you think you might need it, a better approach is to connect to a signal that will be called after the widget is realized automatically, such as Gtk::Widget::signal_draw(). Or simply Glib::signal_connect() to the Gtk::Widget::signal_realize() signal.

void Gtk::Widget::realize_if_needed | ( |  | ) | `[protected]`

::Cairo::RefPtr< ::Cairo::Region> Gtk::Widget::region_intersect | ( | const ::Cairo::RefPtr< ::Cairo::Region > & | region | ) | const

Computes the intersection of a widget's area and region, returning the intersection.

The result may be empty, use cairo_region_is_empty() to check.

Parameters:

  region | A #cairo_region_t, in the same coordinate system as widget->allocation. That is, relative to widget->window for NO_WINDOW widgets; relative to the parent window of widget->window for widgets with their own window.

Returns:
  A newly allocated region holding the intersection of widget and region. The coordinates of the return value are relative to widget->window for NO_WINDOW widgets, and relative to the parent window of widget->window for widgets with their own window.

bool Gtk::Widget::remove_accelerator | ( | const Glib::RefPtr< AccelGroup >& | accel_group,
|  | guint | accel_key,
|  | Gdk::ModifierType | accel_mods
| ) |  |

Removes an accelerator from widget, previously installed with add_accelerator().

Parameters:

  accel_group | Accel group for this widget.
  accel_key | GDK keyval of the accelerator.
  accel_mods | Modifier key combination of the accelerator.

Returns:
  Whether an accelerator was installed and could be removed.

void Gtk::Widget::remove_mnemonic_label | ( | Widget& | label | ) |

Removes a widget from the list of mnemonic labels for this widget.

(See list_mnemonic_labels()). The widget must have previously been added to the list with add_mnemonic_label().

Since gtkmm 2.4:

Parameters:

  label | A Gtk::Widget that was previously set as a mnemnic label for widget with add_mnemonic_label().

void Gtk::Widget::remove_modal_grab | ( |  | ) |

Remove the modal grab of the widget in case it was previously grabbed.

Glib::RefPtr<Gdk::Pixbuf> Gtk::Widget::render_icon_pixbuf | ( | const StockID& | stock_id,
|  | IconSize | size
| ) |  |

A convenience function that uses the theme engine and style settings for widget to look up stock_id and render it to a pixbuf.

stock_id should be a stock icon ID such as Gtk::STOCK_OPEN or Gtk::STOCK_OK. size should be a size such as Gtk::ICON_SIZE_MENU.

The pixels in the returned Gdk::Pixbuf are shared with the rest of the application and should not be modified. The pixbuf should be freed after use with Glib::object_unref().

Since gtkmm 3.0:

Parameters:

  stock_id | A stock ID.
  size | A stock size. A size of (GtkIconSize)-1 means render at the size of the source and don't scale (if there are multiple source sizes, GTK+ picks one of the available sizes).

Returns:
  A new pixbuf, or `0` if the stock ID wasn't known.

void Gtk::Widget::reparent | ( | Widget& | new_parent | ) |

Moves a widget from one Gtk::Container to another, handling reference count issues to avoid destroying the widget.

Parameters:

  new_parent | A Gtk::Container to move the widget into.

void Gtk::Widget::reset_style | ( |  | ) |

Updates the style context of widget and all descendents by updating its widget path.

Gtk::Containers may want to use this on a child when reordering it in a way that a different style might apply to it. See also Gtk::Container::get_path_for_child().

Since gtkmm 3.0:

int Gtk::Widget::send_expose | ( | GdkEvent * | event | ) |

Very rarely-used function.

This function is used to emit an expose event on a widget. This function is not normally used directly. The only time it is used is when propagating an expose event to a child NO_WINDOW widget, and that is normally done using Gtk::Container::propagate_draw().

If you want to force an area of a window to be redrawn, use gdk_window_invalidate_rect() or gdk_window_invalidate_region(). To cause the redraw to be done immediately, follow that call with a call to gdk_window_process_updates().

Parameters:

  event | A expose Gdk::Event.

Returns:
  Return from the event signal emission (`true` if the event was handled).

bool Gtk::Widget::send_focus_change | ( | GdkEvent * | event | ) |

Sends the focus change event to widget.

This function is not meant to be used by applications. The only time it should be used is when it is necessary for a Gtk::Widget to assign focus to a widget that is semantically owned by the first widget even though it's not a direct child - for instance, a search entry in a floating window similar to the quick search in Gtk::TreeView.

An example of its usage is:

[C example ellipted]

Since gtkmm 2.20:

Parameters:

  event | A Gdk::Event of type GDK_FOCUS_CHANGE.

Returns:
  The return value from the event signal emission: `true` if the event was handled, and `false` otherwise.

void Gtk::Widget::set_accel_path | ( | const Glib::ustring & | accel_path,
|  | const Glib::RefPtr< AccelGroup >& | accel_group
| ) |  |

Given an accelerator group, accel_group, and an accelerator path, accel_path, sets up an accelerator in accel_group so whenever the key binding that is defined for accel_path is pressed, widget will be activated.

This removes any accelerators (for any accelerator group) installed by previous calls to set_accel_path(). Associating accelerators with paths allows them to be modified by the user and the modifications to be saved for future use. (See Gtk::AccelMap::save().)

This function is a low level function that would most likely be used by a menu creation system like Gtk::UIManager. If you use Gtk::UIManager, setting up accelerator paths will be done automatically.

Even when you you aren't using Gtk::UIManager, if you only want to set up accelerators on menu items Gtk::MenuItem::set_accel_path() provides a somewhat more convenient interface.

Note that accel_path string will be stored in a Quark. Therefore, if you pass a static string, you can save some memory by interning it first with Glib::intern_static_string().

Parameters:

  accel_path | Path used to look up the accelerator.
  accel_group | A Gtk::AccelGroup.

void Gtk::Widget::set_allocation | ( | const Allocation& | allocation | ) |

Sets the widget's allocation.

This should not be used directly, but from within a widget's size_allocate method.

The allocation set should be the "adjusted" or actual allocation. If you're implementing a Gtk::Container, you want to use size_allocate() instead of set_allocation(). The GtkWidgetClass::adjust_size_allocation virtual method adjusts the allocation inside size_allocate() to create an adjusted allocation.

Since gtkmm 2.18:

Parameters:

  allocation | A pointer to a Gtk::Allocation to copy from.

void Gtk::Widget::set_app_paintable | ( | bool | app_paintable = `true` | ) |

Sets whether the application intends to draw on the widget in an Gtk::Widget::signal_draw() handler.

This is a hint to the widget and does not affect the behavior of the GTK+ core; many widgets ignore this flag entirely. For widgets that do pay attention to the flag, such as Gtk::EventBox and Gtk::Window, the effect is to suppress default themed drawing of the widget's background. (Children of the widget will still be drawn.) The application is then entirely responsible for drawing the widget background.

Note that the background is still drawn when the widget is mapped.

Parameters:

  app_paintable | `true` if the application will paint on the widget.

void Gtk::Widget::set_can_default | ( | bool | can_default = `true` | ) |

Specifies whether widget can be a default widget.

See grab_default() for details about the meaning of "default".

Since gtkmm 2.18:

Parameters:

  can_default | Whether or not widget can be a default widget.

void Gtk::Widget::set_can_focus | ( | bool | can_focus = `true` | ) |

Specifies whether widget can own the input focus.

See grab_focus() for actually setting the input focus on a widget.

Since gtkmm 2.18:

Parameters:

  can_focus | Whether or not widget can own the input focus.

void Gtk::Widget::set_child_visible | ( | bool | is_visible = `true` | ) |

Sets whether widget should be mapped along with its when its parent is mapped and widget has been shown with show().

The child visibility can be set for widget before it is added to a container with set_parent(), to avoid mapping children unnecessary before immediately unmapping them. However it will be reset to its default state of `true` when the widget is removed from a container.

Note that changing the child visibility of a widget does not queue a resize on the widget. Most of the time, the size of a widget is computed from all visible children, whether or not they are mapped. If this is not the case, the container can queue a resize itself.

This function is only useful for container implementations and never should be called by an application.

Parameters:

  is_visible | If `true`, widget should be mapped along with its parent.

void Gtk::Widget::set_composite_name | ( | const Glib::ustring & | name | ) |

Sets a widgets composite name.

The widget must be a composite child of its parent; see push_composite_child().

Parameters:

  name | The name to set.

static void Gtk::Widget::set_default_direction | ( | TextDirection | dir | ) | `[static]`

Sets the default reading direction for widgets where the direction has not been explicitly set by set_direction().

Parameters:

  dir | The new default direction. This cannot be Gtk::TEXT_DIR_NONE.

void Gtk::Widget::set_device_enabled | ( | const Glib::RefPtr< Gdk::Device >& | device,
|  | bool | enabled = `true`
| ) |  |

Enables or disables a Gdk::Device to interact with widget and all its children.

It does so by descending through the Gdk::Window hierarchy and enabling the same mask that is has for core events (i.e. the one that gdk_window_get_events() returns).

Since gtkmm 3.0:

Parameters:

  device | A Gdk::Device.
  enabled | Whether to enable the device.

void Gtk::Widget::set_device_events | ( | const Glib::RefPtr< const Gdk::Device >& | device,
|  | Gdk::EventMask | events
| ) |  |

Sets the device event mask (see Gdk::EventMask) for a widget.

The event mask determines which events a widget will receive from device. Keep in mind that different widgets have different default event masks, and by changing the event mask you may disrupt a widget's functionality, so be careful. This function must be called while a widget is unrealized. Consider add_device_events() for widgets that are already realized, or if you want to preserve the existing event mask. This function can't be used with Gtk::NO_WINDOW widgets; to get events on those widgets, place them inside a Gtk::EventBox and receive events on the event box.

Since gtkmm 3.0:

Parameters:

  device | A Gdk::Device.
  events | Event mask.

void Gtk::Widget::set_direction | ( | TextDirection | dir | ) |

Sets the reading direction on a particular widget.

This direction controls the primary direction for widgets containing text, and also the direction in which the children of a container are packed. The ability to set the direction is present in order so that correct localization into languages with right-to-left reading directions can be done. Generally, applications will let the default reading direction present, except for containers where the containers are arranged in an order that is explicitely visual rather than logical (such as buttons for text justification).

If the direction is set to Gtk::TEXT_DIR_NONE, then the value set by set_default_direction() will be used.

Parameters:

  dir | The new direction.

void Gtk::Widget::set_double_buffered | ( | bool | double_buffered = `true` | ) |

Widgets are double buffered by default; you can use this function to turn off the buffering.

"Double buffered" simply means that gdk_window_begin_paint_region() and gdk_window_end_paint() are called automatically around expose events sent to the widget. gdk_window_begin_paint() diverts all drawing to a widget's window to an offscreen buffer, and gdk_window_end_paint() draws the buffer to the screen. The result is that users see the window update in one smooth step, and don't see individual graphics primitives being rendered.

In very simple terms, double buffered widgets don't flicker, so you would only use this function to turn off double buffering if you had special needs and really knew what you were doing.

Note:
  if you turn off double-buffering, you have to handle expose events, since even the clearing to the background color or pixmap will not happen automatically (as it is done in gdk_window_begin_paint()).

Parameters:

  double_buffered | `true` to double-buffer a widget.

void Gtk::Widget::set_events | ( | Gdk::EventMask | events | ) |

Sets the event mask (see Gdk::EventMask) for a widget.

The event mask determines which events a widget will receive. Keep in mind that different widgets have different default event masks, and by changing the event mask you may disrupt a widget's functionality, so be careful. This function must be called while a widget is unrealized. Consider add_events() for widgets that are already realized, or if you want to preserve the existing event mask. This function can't be used with Gtk::NO_WINDOW widgets; to get events on those widgets, place them inside a Gtk::EventBox and receive events on the event box.

Parameters:

  events | Event mask.

void Gtk::Widget::set_halign | ( | Align | align | ) |

Sets the horizontal alignment of widget.

See the Gtk::Widget::property_halign() property.

Parameters:

  align | The horizontal alignment.

void Gtk::Widget::set_has_tooltip | ( | bool | has_tooltip = `TRUE` | ) |

Sets the has-tooltip property on widget to has_tooltip.

See Gtk::Widget::property_has_tooltip() for more information.

Since gtkmm 2.12:

Parameters:

  has_tooltip | Whether or not widget has a tooltip.

void Gtk::Widget::set_has_window | ( | bool | has_window = `true` | ) | `[protected]`

Specifies whether widget has a Gdk::Window of its own.

Note that all realized widgets have a non-`0` "window" pointer (get_window() never returns a `0` window when a widget is realized), but for many of them it's actually the Gdk::Window of one of its parent widgets. Widgets that do not create a window for themselves in Gtk::Widget::signal_realize() must announce this by calling this function with has_window = `false`.

This function should only be called by widget implementations, and they should call it in their init() function.

Since gtkmm 2.18:

Parameters:

  has_window | Whether or not widget has a window.

void Gtk::Widget::set_hexpand | ( | bool | expand = `true` | ) |

Sets whether the widget would like any available extra horizontal space.

When a user resizes a Gtk::Window, widgets with expand=`true` generally receive the extra space. For example, a list or scrollable area or document in your window would often be set to expand.

Call this function to set the expand flag if you would like your widget to become larger horizontally when the window has extra room.

By default, widgets automatically expand if any of their children want to expand. (To see if a widget will automatically expand given its current children and state, call compute_expand(). A container can decide how the expandability of children affects the expansion of the container by overriding the compute_expand virtual method on Gtk::Widget.).

Setting hexpand explicitly with this function will override the automatic expand behavior.

This function forces the widget to expand or not to expand, regardless of children. The override occurs because set_hexpand() sets the hexpand-set property (see set_hexpand_set()) which causes the widget's hexpand value to be used, rather than looking at children and widget state.

Parameters:

  expand | Whether to expand.

void Gtk::Widget::set_hexpand_set | ( | bool | set = `true` | ) |

Sets whether the hexpand flag (see get_hexpand()) will be used.

The hexpand-set property will be set automatically when you call set_hexpand() to set hexpand, so the most likely reason to use this function would be to unset an explicit expand flag.

If hexpand is set, then it overrides any computed expand value based on child widgets. If hexpand is not set, then the expand value depends on whether any children of the widget would like to expand.

There are few reasons to use this function, but it's here for completeness and consistency.

Parameters:

  set | Value for hexpand-set property.

void Gtk::Widget::set_mapped | ( | bool | mapped = `true` | ) | `[protected]`

Marks the widget as being realized.

This function should only ever be called in a derived widget's "map" or "unmap" implementation.

Since gtkmm 2.20:

Parameters:

  mapped | `true` to mark the widget as mapped.

void Gtk::Widget::set_margin_bottom | ( | int | margin | ) |

Sets the bottom margin of widget.

See the Gtk::Widget::property_margin_bottom() property.

Since gtkmm 3.0:

Parameters:

  margin | The bottom margin.

void Gtk::Widget::set_margin_left | ( | int | margin | ) |

Sets the left margin of widget.

See the Gtk::Widget::property_margin_left() property.

Since gtkmm 3.0:

Parameters:

  margin | The left margin.

void Gtk::Widget::set_margin_right | ( | int | margin | ) |

Sets the right margin of widget.

See the Gtk::Widget::property_margin_right() property.

Since gtkmm 3.0:

Parameters:

  margin | The right margin.

void Gtk::Widget::set_margin_top | ( | int | margin | ) |

Sets the top margin of widget.

See the Gtk::Widget::property_margin_top() property.

Since gtkmm 3.0:

Parameters:

  margin | The top margin.

void Gtk::Widget::set_name | ( | const Glib::ustring & | name | ) |

Widgets can be named, which allows you to refer to them from a CSS file.

You can apply a style to widgets with a particular name in the CSS file. See the documentation for the CSS syntax (on the same page as the docs for Gtk::StyleContext).

Note that the CSS syntax has certain special characters to delimit and represent elements in a selector (period, #, >, *...), so using these will make your widget impossible to match by name. Any combination of alphanumeric symbols, dashes and underscores will suffice.

Parameters:

  name | Name for the widget.

Reimplemented from Gtk::Buildable.

void Gtk::Widget::set_no_show_all | ( | bool | no_show_all = `true` | ) |

Sets the Gtk::Widget::property_no_show_all() property, which determines whether calls to show_all() will affect this widget.

This is mostly for use in constructing widget hierarchies with externally controlled visibility, see Gtk::UIManager.

Since gtkmm 2.4:

Parameters:

  no_show_all | The new value for the "no-show-all" property.

void Gtk::Widget::set_parent | ( | Widget& | parent | ) |

This function is useful only when implementing subclasses of Gtk::Container.

Sets the container as the parent of widget, and takes care of some details such as updating the state and style of the child to reflect its new location. The opposite function is unparent().

Parameters:

  parent | Parent container.

void Gtk::Widget::set_parent_window | ( | const Glib::RefPtr< const Gdk::Window >& | parent_window | ) |

Sets a non default parent window for widget.

For GtkWindow classes, setting a parent_window effects whether the window is a toplevel window or can be embedded into other widgets.

<note> For GtkWindow classes, this needs to be called before the window is realized. </note>

Parameters:

  parent_window | The new parent window.

void Gtk::Widget::set_realized | ( | bool | realized = `true` | ) | `[protected]`

Marks the widget as being realized.

This function should only ever be called in a derived widget's "realize" or "unrealize" implementation.

Since gtkmm 2.20:

Parameters:

  realized | `true` to mark the widget as realized.

void Gtk::Widget::set_receives_default | ( | bool | receives_default = `true` | ) |

Specifies whether widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default.

See grab_default() for details about the meaning of "default".

Since gtkmm 2.18:

Parameters:

  receives_default | Whether or not widget can be a default widget.

void Gtk::Widget::set_redraw_on_allocate | ( | bool | redraw_on_allocate = `true` | ) |

Sets whether the entire widget is queued for drawing when its size allocation changes.

By default, this setting is `true` and the entire widget is redrawn on every size change. If your widget leaves the upper left unchanged when made bigger, turning this setting off will improve performance.

Note that for NO_WINDOW widgets setting this flag to `false` turns off all allocation on resizing: the widget will not even redraw if its position changes; this is to allow containers that don't draw anything to avoid excess invalidations. If you set this flag on a NO_WINDOW widget that does draw on widget->window, you are responsible for invalidating both the old and new allocation of the widget when the widget is moved and responsible for invalidating regions newly when the widget increases size.

Parameters:

  redraw_on_allocate | If `true`, the entire widget will be redrawn when it is allocated to a new size. Otherwise, only the new portion of the widget will be redrawn.

void Gtk::Widget::set_sensitive | ( | bool | sensitive = `true` | ) |

Sets the sensitivity of a widget.

A widget is sensitive if the user can interact with it. Insensitive widgets are "grayed out" and the user can't interact with them. Insensitive widgets are known as "inactive", "disabled", or "ghosted" in some other toolkits.

Parameters:

  sensitive | `true` to make the widget sensitive.

void Gtk::Widget::set_size_request | ( | int | width = `-1`,
|  | int | height = `-1`
| ) |  |

Sets the minimum size of a widget; that is, the widget's size request will be width by height.

You can use this function to force a widget to be either larger or smaller than it normally would be.

In most cases, Gtk::Window::set_default_size() is a better choice for toplevel windows than this function; setting the default size will still allow users to shrink the window. Setting the size request will force them to leave the window at least as large as the size request. When dealing with window sizes, Gtk::Window::set_geometry_hints() can be a useful function as well.

Note the inherent danger of setting any fixed size - themes, translations into other languages, different fonts, and user action can all change the appropriate size for a given widget. So, it's basically impossible to hardcode a size that will always be correct.

The size request of a widget is the smallest size a widget can accept while still functioning well and drawing itself correctly. However in some strange cases a widget may be allocated less than its requested size, and in many cases a widget may be allocated more space than it requested.

If the size request in a given direction is -1 (unset), then the "natural" size request of the widget will be used instead.

Widgets can't actually be allocated a size less than 1 by 1, but you can pass 0,0 to this function to mean "as small as possible."

The size request set here does not include any margin from the Gtk::Widget properties margin-left, margin-right, margin-top, and margin-bottom, but it does include pretty much all other padding or border properties set by any subclass of Gtk::Widget.

Parameters:

  width | Width widget should request, or -1 to unset.
  height | Height widget should request, or -1 to unset.

void Gtk::Widget::set_state | ( | StateType | state | ) |

This function is for use in widget implementations.

Sets the state of a widget (insensitive, prelighted, etc.) Usually you should set the state using wrapper functions such as set_sensitive().

Deprecated: 3.0. Use set_state_flags() instead.

Deprecated:
  Use set_state_flags() instead.

Parameters:

  state | New state for widget.

void Gtk::Widget::set_state_flags | ( | StateFlags | flags,
|  | bool | clear = `true`
| ) |  |

This function is for use in widget implementations.

Turns on flag values in the current widget state (insensitive, prelighted, etc.).

It is worth mentioning that any other state than Gtk::STATE_FLAG_INSENSITIVE, will be propagated down to all non-internal children if widget is a Gtk::Container, while Gtk::STATE_FLAG_INSENSITIVE itself will be propagated down to all Gtk::Container children by different means than turning on the state flag down the hierarchy, both get_state_flags() and is_sensitive() will make use of these.

Since gtkmm 3.0:

Parameters:

  flags | State flags to turn on.
  clear | Whether to clear state before turning on flags.

void Gtk::Widget::set_support_multidevice | ( | bool | support_multidevice = `true` | ) |

Enables or disables multiple pointer awareness.

If this setting is `true`, widget will start receiving multiple, per device enter/leave events. Note that if custom Gdk::Windows are created in Gtk::Widget::signal_realize(), gdk_window_set_support_multidevice() will have to be called manually on them.

Since gtkmm 3.0:

Parameters:

  support_multidevice | `true` to support input from multiple devices.

void Gtk::Widget::set_tooltip_markup | ( | const Glib::ustring & | markup | ) |

Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language.

This function will take care of setting GtkWidget:has-tooltip to `true` and of the default handler for the GtkWidget::query-tooltip signal.

See also the GtkWidget:tooltip-markup property and Gtk::Tooltip::set_markup().

Since gtkmm 2.12:

Parameters:

  markup | The contents of the tooltip for widget.

Reimplemented in Gtk::ToolItem.

void Gtk::Widget::set_tooltip_text | ( | const Glib::ustring & | text | ) |

Sets text as the contents of the tooltip.

This function will take care of setting Gtk::Widget::property_has_tooltip() to `true` and of the default handler for the Gtk::Widget::signal_query_tooltip() signal.

See also the Gtk::Widget::property_tooltip_text() property and Gtk::Tooltip::set_text().

Since gtkmm 2.12:

Parameters:

  text | The contents of the tooltip for widget.

Reimplemented in Gtk::ToolItem.

void Gtk::Widget::set_tooltip_window | ( | Window& | widget | ) |

Replaces the default, usually yellow, window used for displaying tooltips with custom_window.

GTK+ will take care of showing and hiding custom_window at the right moment, to behave likewise as the default tooltip window. If custom_window is `0`, the default tooltip window will be used.

If the custom window should have the default theming it needs to have the name "gtk-tooltip", see set_name().

Since gtkmm 2.12:

Parameters:

  custom_window | A Gtk::Window, or `0`.

void Gtk::Widget::set_valign | ( | Align | align | ) |

Sets the vertical alignment of widget.

See the Gtk::Widget::property_valign() property.

Parameters:

  align | The vertical alignment.

void Gtk::Widget::set_vexpand | ( | bool | expand = `true` | ) |

Sets whether the widget would like any available extra vertical space.

See set_hexpand() for more detail.

Parameters:

  expand | Whether to expand.

void Gtk::Widget::set_vexpand_set | ( | bool | set = `true` | ) |

Sets whether the vexpand flag (see get_vexpand()) will be used.

See set_hexpand_set() for more detail.

Parameters:

  set | Value for vexpand-set property.

void Gtk::Widget::set_visible | ( | bool | visible = `true` | ) |

Sets the visibility state of widget.

Note that setting this to `true` doesn't mean the widget is actually viewable, see get_visible().

This function simply calls show() or hide() but is nicer to use when the visibility of the widget depends on some condition.

Since gtkmm 2.18:

Parameters:

  visible | Whether the widget should be shown or not.

void Gtk::Widget::set_window | ( | const Glib::RefPtr< Gdk::Window >& | window | ) | `[protected]`

Sets a widget's window.

This function should only be used in a widget's Gtk::Widget::on_realize() implementation. The window passed is usually either a new window created with Gdk::Window::create(), or the window of its parent widget as returned by get_parent_window().

Widgets must indicate whether they will create their own Gdk::Window by calling set_has_window(). This is usually done in the widget's constructor.

This function should only be called by custom widget implementations, and they should call it in their on_realize() function.

Since gtkmm 2.18:

Parameters:

  window | A Gdk::Window.

void Gtk::Widget::shape_combine_region | ( | const ::Cairo::RefPtr< const ::Cairo::Region > & | region | ) |

Sets a shape for this widget's GDK window.

This allows for transparent windows etc., see gdk_window_shape_combine_region() for more information.

Since gtkmm 3.0:

Parameters:

  region | Shape to be added, or `0` to remove an existing shape.

static bool Gtk::Widget::should_draw_window | ( | const ::Cairo::RefPtr< const ::Cairo::Context > & | cr,
|  | const Glib::RefPtr< const Gdk::Window >& | window
| ) |  | `[static, protected]`

This function is supposed to be called in Gtk::Widget::signal_draw() implementations for widgets that support multiple windows.

cr must be untransformed from invoking of the draw function. This function will return `true` if the contents of the given window are supposed to be drawn and `false` otherwise. Note that when the drawing was not initiated by the windowing system this function will return `true` for all windows, so you need to draw the bottommost window first. Also, do not use "else if" statements to check which window should be drawn.

Since gtkmm 3.0:

Parameters:

  cr | A cairo context.
  window | The window to check. window may not be an input-only window.

Returns:
  `true` if window should be drawn.

void Gtk::Widget::show | ( |  | ) |

Flags a widget to be displayed.

Any widget that isn't shown will not appear on the screen. If you want to show all the widgets in a container, it's easier to call show_all() on the container, instead of individually showing the widgets.

Remember that you have to show the containers containing a widget, in addition to the widget itself, before it will appear onscreen.

When a toplevel container is shown, it is immediately realized and mapped; other shown widgets are realized and mapped when their toplevel container is realized and mapped.

void Gtk::Widget::show_all | ( |  | ) |

Recursively shows a widget, and any child widgets (if the widget is a container).

virtual void Gtk::Widget::show_all_vfunc | ( |  | ) | `[protected, virtual]`

void Gtk::Widget::show_now | ( |  | ) |

Shows a widget.

If the widget is an unmapped toplevel widget (i.e. a Gtk::Window that has not yet been shown), enter the main loop and wait for the window to actually be mapped. Be careful; because the main loop is running, anything can happen during this function.

Glib::SignalProxy1< bool,GdkEventButton* > Gtk::Widget::signal_button_press_event | ( |  | ) |

Event triggered by user pressing button.

Slot Prototype:
  `bool on_my_button_press_event(GdkEventButton* event)`

The signal_button_press_event() signal will be emitted when a button (typically from a mouse) is pressed.

To receive this signal, the Gdk::Window associated to the widget needs to enable the Gdk::BUTTON_PRESS_MASK mask.

This signal will be sent to the grab widget if there is one.

Parameters:

  event | The Gdk::EventButton which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy1< bool,GdkEventButton* > Gtk::Widget::signal_button_release_event | ( |  | ) |

Event triggered by user releasing button.

Slot Prototype:
  `bool on_my_button_release_event(GdkEventButton* event)`

The signal_button_release_event() signal will be emitted when a button (typically from a mouse) is released.

To receive this signal, the Gdk::Window associated to the widget needs to enable the Gdk::BUTTON_RELEASE_MASK mask.

This signal will be sent to the grab widget if there is one.

Parameters:

  event | The Gdk::EventButton which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy1< void,GParamSpec* > Gtk::Widget::signal_child_notify | ( |  | ) |

Slot Prototype:
  `void on_my_child_notify(GParamSpec* pspec)`

The signal_child_notify() signal is emitted for each child property that has changed on an object. The signal's detail holds the property name.

Parameters:

  pspec | The ParamSpec of the changed child property.

Glib::SignalProxy0< void > Gtk::Widget::signal_composited_changed | ( |  | ) |

Slot Prototype:
  `void on_my_composited_changed()`

The signal_composited_changed() signal is emitted when the composited status of widgets screen changes. See gdk_screen_is_composited().

Glib::SignalProxy1< bool,GdkEventConfigure* > Gtk::Widget::signal_configure_event | ( |  | ) |

Event triggered by a window resizing.

Slot Prototype:
  `bool on_my_configure_event(GdkEventConfigure* event)`

The signal_configure_event() signal will be emitted when the size, position or stacking of the widget's window has changed.

To receive this signal, the Gdk::Window associated to the widget needs to enable the Gdk::STRUCTURE_MASK mask. GDK will enable this mask automatically for all new windows.

Parameters:

  event | The Gdk::EventConfigure which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy1< bool,GdkEventExpose* > Gtk::Widget::signal_damage_event | ( |  | ) |

Slot Prototype:
  `bool on_my_damage_event(GdkEventExpose* event)`

Emitted when a redirected window belonging to widget gets drawn into. The region/area members of the event shows what area of the redirected drawable was drawn into.

Since gtkmm 2.14:

Parameters:

  event | The Gdk::EventExpose event.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy1< bool,GdkEventAny* > Gtk::Widget::signal_delete_event | ( |  | ) |

Slot Prototype:
  `bool on_my_delete_event(GdkEventAny* event)`

The signal_delete_event() signal is emitted if a user requests that a toplevel window is closed. The default handler for this signal destroys the window. Connecting Gtk::Widget::hide_on_delete() to this signal will cause the window to be hidden instead, so that it can later be shown again without reconstructing it.

Parameters:

  event | The event which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy1< void,TextDirection > Gtk::Widget::signal_direction_changed | ( |  | ) |

Slot Prototype:
  `void on_my_direction_changed(TextDirection direction)`

The signal_direction_changed() signal is emitted when the text direction of a widget changes.

Parameters:

  previous_direction | The previous text direction of widget.

Glib::SignalProxy1< void,const Glib::RefPtr<Gdk::DragContext>& > Gtk::Widget::signal_drag_begin | ( |  | ) |

Slot Prototype:
  `void on_my_drag_begin(const Glib::RefPtr<Gdk::DragContext>& context)`

The signal_drag_begin() signal is emitted on the drag source when a drag is started. A typical reason to connect to this signal is to set up a custom drag icon with gtk_drag_source_set_icon().

Note that some widgets set up a drag icon in the default handler of this signal, so you may have to use Glib::signal_connect_after() to override what the default handler did.

Parameters:

  drag_context | The drag context.

Glib::SignalProxy1< void,const Glib::RefPtr<Gdk::DragContext>& > Gtk::Widget::signal_drag_data_delete | ( |  | ) |

Slot Prototype:
  `void on_my_drag_data_delete(const Glib::RefPtr<Gdk::DragContext>& context)`

The signal_drag_data_delete() signal is emitted on the drag source when a drag with the action Gdk::ACTION_MOVE is successfully completed. The signal handler is responsible for deleting the data that has been dropped. What "delete" means depends on the context of the drag operation.

Parameters:

  drag_context | The drag context.

Glib::SignalProxy4< void,const Glib::RefPtr<Gdk::DragContext>&,SelectionData&,guint,guint > Gtk::Widget::signal_drag_data_get | ( |  | ) |

Slot Prototype:
  `void on_my_drag_data_get(const Glib::RefPtr<Gdk::DragContext>& context, SelectionData& selection_data, guint info, guint time)`

The signal_drag_data_get() signal is emitted on the drag source when the drop site requests the data which is dragged. It is the responsibility of the signal handler to fill data with the data in the format which is indicated by info. See gtk_selection_data_set() and gtk_selection_data_set_text().

Parameters:

  drag_context | The drag context.
  data | The Gtk::SelectionData to be filled with the dragged data.
  info | The info that has been registered with the target in the Gtk::TargetList.
  time | The timestamp at which the data was requested.

Glib::SignalProxy6< void,const Glib::RefPtr<Gdk::DragContext>&,int,int,const SelectionData&,guint,guint > Gtk::Widget::signal_drag_data_received | ( |  | ) |

Slot Prototype:
  `void on_my_drag_data_received(const Glib::RefPtr<Gdk::DragContext>& context, int x, int y, const SelectionData& selection_data, guint info, guint time)`

The signal_drag_data_received() signal is emitted on the drop site when the dragged data has been received. If the data was received in order to determine whether the drop will be accepted, the handler is expected to call gdk_drag_status() and not finish the drag. If the data was received in response to a Gtk::Widget::signal_drag_drop() signal (and this is the last target to be received), the handler for this signal is expected to process the received data and then call gtk_drag_finish(), setting the success parameter depending on whether the data was processed successfully.

The handler may inspect and modify drag_context->action before calling gtk_drag_finish(), e.g. to implement Gdk::ACTION_ASK as shown in the following example:

[C example ellipted]

Parameters:

  drag_context | The drag context.
  x | Where the drop happened.
  y | Where the drop happened.
  data | The received data.
  info | The info that has been registered with the target in the Gtk::TargetList.
  time | The timestamp at which the data was received.

Glib::SignalProxy4< bool,const Glib::RefPtr<Gdk::DragContext>&,int,int,guint > Gtk::Widget::signal_drag_drop | ( |  | ) |

Slot Prototype:
  `bool on_my_drag_drop(const Glib::RefPtr<Gdk::DragContext>& context, int x, int y, guint time)`

The signal_drag_drop() signal is emitted on the drop site when the user drops the data onto the widget. The signal handler must determine whether the cursor position is in a drop zone or not. If it is not in a drop zone, it returns `false` and no further processing is necessary. Otherwise, the handler returns `true`. In this case, the handler must ensure that gtk_drag_finish() is called to let the source know that the drop is done. The call to gtk_drag_finish() can be done either directly or in a Gtk::Widget::signal_drag_data_received() handler which gets triggered by calling gtk_drag_get_data() to receive the data for one or more of the supported targets.

Parameters:

  drag_context | The drag context.
  x | The x coordinate of the current cursor position.
  y | The y coordinate of the current cursor position.
  time | The timestamp of the motion event.

Returns:
  Whether the cursor position is in a drop zone.

Glib::SignalProxy1< void,const Glib::RefPtr<Gdk::DragContext>& > Gtk::Widget::signal_drag_end | ( |  | ) |

Slot Prototype:
  `void on_my_drag_end(const Glib::RefPtr<Gdk::DragContext>& context)`

The signal_drag_end() signal is emitted on the drag source when a drag is finished. A typical reason to connect to this signal is to undo things done in Gtk::Widget::signal_drag_begin().

Parameters:

  drag_context | The drag context.

Glib::SignalProxy2< bool,const Glib::RefPtr<Gdk::DragContext>&,DragResult > Gtk::Widget::signal_drag_failed | ( |  | ) |

Slot Prototype:
  `bool on_my_drag_failed(const Glib::RefPtr<Gdk::DragContext>& context, DragResult result)`

The signal_drag_failed() signal is emitted on the drag source when a drag has failed. The signal handler may hook custom code to handle a failed DND operation based on the type of error, it returns `true` is the failure has been already handled (not showing the default "drag operation failed" animation), otherwise it returns `false`.

Since gtkmm 2.12:

Parameters:

  drag_context | The drag context.
  result | The result of the drag operation.

Returns:
  `true` if the failed drag operation has been already handled.

Glib::SignalProxy2< void,const Glib::RefPtr<Gdk::DragContext>&,guint > Gtk::Widget::signal_drag_leave | ( |  | ) |

Slot Prototype:
  `void on_my_drag_leave(const Glib::RefPtr<Gdk::DragContext>& context, guint time)`

The signal_drag_leave() signal is emitted on the drop site when the cursor leaves the widget. A typical reason to connect to this signal is to undo things done in Gtk::Widget::signal_drag_motion(), e.g. undo highlighting with gtk_drag_unhighlight()

Parameters:

  drag_context | The drag context.
  time | The timestamp of the motion event.

Glib::SignalProxy4< bool,const Glib::RefPtr<Gdk::DragContext>&,int,int,guint > Gtk::Widget::signal_drag_motion | ( |  | ) |

Slot Prototype:
  `bool on_my_drag_motion(const Glib::RefPtr<Gdk::DragContext>& context, int x, int y, guint time)`

The drag-motion signal is emitted on the drop site when the user moves the cursor over the widget during a drag. The signal handler must determine whether the cursor position is in a drop zone or not. If it is not in a drop zone, it returns `false` and no further processing is necessary. Otherwise, the handler returns `true`. In this case, the handler is responsible for providing the necessary information for displaying feedback to the user, by calling gdk_drag_status().

If the decision whether the drop will be accepted or rejected can't be made based solely on the cursor position and the type of the data, the handler may inspect the dragged data by calling gtk_drag_get_data() and defer the gdk_drag_status() call to the Gtk::Widget::signal_drag_data_received() handler. Note that you cannot not pass Gtk::DEST_DEFAULT_DROP, Gtk::DEST_DEFAULT_MOTION or Gtk::DEST_DEFAULT_ALL to gtk_drag_dest_set() when using the drag-motion signal that way.

Also note that there is no drag-enter signal. The drag receiver has to keep track of whether he has received any drag-motion signals since the last Gtk::Widget::signal_drag_leave() and if not, treat the drag-motion signal as an "enter" signal. Upon an "enter", the handler will typically highlight the drop site with gtk_drag_highlight().

[C example ellipted]

Parameters:

  drag_context | The drag context.
  x | The x coordinate of the current cursor position.
  y | The y coordinate of the current cursor position.
  time | The timestamp of the motion event.

Returns:
  Whether the cursor position is in a drop zone.

Glib::SignalProxy1< bool,const ::Cairo::RefPtr< ::Cairo::Context>& > Gtk::Widget::signal_draw | ( |  | ) |

Slot Prototype:
  `bool on_my_draw(const ::Cairo::RefPtr< ::Cairo::Context>& cr)`

This signal is emitted when a widget is supposed to render itself. The widget's top left corner must be painted at the origin of the passed in context and be sized to the values returned by Gtk::Widget::get_allocated_width() and Gtk::Widget::get_allocated_height().

Signal handlers connected to this signal can modify the cairo context passed as cr in any way they like and don't need to restore it. The signal emission takes care of calling cairo_save() before and cairo_restore() after invoking the handler.

Since gtkmm 3.0:

Parameters:

  cr | The cairo context to draw to.

Glib::SignalProxy1< bool,GdkEventCrossing* > Gtk::Widget::signal_enter_notify_event | ( |  | ) |

Event triggered by pointer entering widget area.

Slot Prototype:
  `bool on_my_enter_notify_event(GdkEventCrossing* event)`

The signal_enter_notify_event() will be emitted when the pointer enters the widget's window.

To receive this signal, the Gdk::Window associated to the widget needs to enable the Gdk::ENTER_NOTIFY_MASK mask.

This signal will be sent to the grab widget if there is one.

Parameters:

  event | The Gdk::EventCrossing which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy1< bool,GdkEvent* > Gtk::Widget::signal_event | ( |  | ) |

Slot Prototype:
  `bool on_my_event(GdkEvent* event)`

The GTK+ main loop will emit three signals for each GDK event delivered to a widget: one generic signal_event() signal, another, more specific, signal that matches the type of event delivered (e.g. Gtk::Widget::signal_key_press_event()) and finally a generic Gtk::Widget::signal_event_after() signal.

Parameters:

  event | The Gdk::Event which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event and to cancel the emission of the second specific signal_event() signal. `false` to propagate the event further and to allow the emission of the second signal. The signal_event_after() signal is emitted regardless of the return value.

Glib::SignalProxy1< void,GdkEvent* > Gtk::Widget::signal_event_after | ( |  | ) |

Slot Prototype:
  `void on_my_event_after(GdkEvent* event)`

After the emission of the Gtk::Widget::signal_event() signal and (optionally) the second more specific signal, signal_event_after() will be emitted regardless of the previous two signals handlers return values.

Parameters:

  event | The Gdk::Event which triggered this signal.

Glib::SignalProxy1< bool,DirectionType > Gtk::Widget::signal_focus | ( |  | ) |

Slot Prototype:
  `bool on_my_focus(DirectionType direction)`

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy1< bool,GdkEventFocus* > Gtk::Widget::signal_focus_in_event | ( |  | ) |

Slot Prototype:
  `bool on_my_focus_in_event(GdkEventFocus* event)`

The signal_focus_in_event() signal will be emitted when the keyboard focus enters the widget's window.

To receive this signal, the Gdk::Window associated to the widget needs to enable the Gdk::FOCUS_CHANGE_MASK mask.

Parameters:

  event | The Gdk::EventFocus which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy1< bool,GdkEventFocus* > Gtk::Widget::signal_focus_out_event | ( |  | ) |

Slot Prototype:
  `bool on_my_focus_out_event(GdkEventFocus* event)`

The signal_focus_out_event() signal will be emitted when the keyboard focus leaves the widget's window.

To receive this signal, the Gdk::Window associated to the widget needs to enable the Gdk::FOCUS_CHANGE_MASK mask.

Parameters:

  event | The Gdk::EventFocus which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy1< bool,GdkEventGrabBroken* > Gtk::Widget::signal_grab_broken_event | ( |  | ) |

Slot Prototype:
  `bool on_my_grab_broken_event(GdkEventGrabBroken* event)`

Emitted when a pointer or keyboard grab on a window belonging to widget gets broken.

On X11, this happens when the grab window becomes unviewable (i.e. it or one of its ancestors is unmapped), or if the same application grabs the pointer or keyboard again.

Since gtkmm 2.8:

Parameters:

  event | The Gdk::EventGrabBroken event.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy0< void > Gtk::Widget::signal_grab_focus | ( |  | ) |

Slot Prototype:
  `void on_my_grab_focus()`

Glib::SignalProxy1< void,bool > Gtk::Widget::signal_grab_notify | ( |  | ) |

Slot Prototype:
  `void on_my_grab_notify(bool was_grabbed)`

The signal_grab_notify() signal is emitted when a widget becomes shadowed by a GTK+ grab (not a pointer or keyboard grab) on another widget, or when it becomes unshadowed due to a grab being removed.

A widget is shadowed by a gtk_grab_add() when the topmost grab widget in the grab stack of its window group is not its ancestor.

Parameters:

  was_grabbed | `false` if the widget becomes shadowed, `true` if it becomes unshadowed.

Glib::SignalProxy0< void > Gtk::Widget::signal_hide | ( |  | ) |

Slot Prototype:
  `void on_my_hide()`

Glib::SignalProxy1< void,Widget* > Gtk::Widget::signal_hierarchy_changed | ( |  | ) |

Slot Prototype:
  `void on_my_hierarchy_changed(Widget* previous_toplevel)`

The signal_hierarchy_changed() signal is emitted when the anchored state of a widget changes. A widget is <firstterm>anchored</firstterm> when its toplevel ancestor is a Gtk::Window. This signal is emitted when a widget changes from un-anchored to anchored or vice-versa.

Parameters:

  previous_toplevel | The previous toplevel ancestor, or `0` if the widget was previously unanchored.

Glib::SignalProxy1< bool,GdkEventKey* > Gtk::Widget::signal_key_press_event | ( |  | ) |

Event triggered by a key press will widget has focus.

Slot Prototype:
  `bool on_my_key_press_event(GdkEventKey* event)`

The signal_key_press_event() signal is emitted when a key is pressed. The signal emission will reoccur at the key-repeat rate when the key is kept pressed.

To receive this signal, the Gdk::Window associated to the widget needs to enable the Gdk::KEY_PRESS_MASK mask.

This signal will be sent to the grab widget if there is one.

Parameters:

  event | The Gdk::EventKey which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy1< bool,GdkEventKey* > Gtk::Widget::signal_key_release_event | ( |  | ) |

Event triggered by a key release will widget has focus.

Slot Prototype:
  `bool on_my_key_release_event(GdkEventKey* event)`

The signal_key_release_event() signal is emitted when a key is released.

To receive this signal, the Gdk::Window associated to the widget needs to enable the Gdk::KEY_RELEASE_MASK mask.

This signal will be sent to the grab widget if there is one.

Parameters:

  event | The Gdk::EventKey which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy1< bool,GdkEventCrossing* > Gtk::Widget::signal_leave_notify_event | ( |  | ) |

Event triggered by pointer leaving widget area.

Slot Prototype:
  `bool on_my_leave_notify_event(GdkEventCrossing* event)`

The signal_leave_notify_event() will be emitted when the pointer leaves the widget's window.

To receive this signal, the Gdk::Window associated to the widget needs to enable the Gdk::LEAVE_NOTIFY_MASK mask.

This signal will be sent to the grab widget if there is one.

Parameters:

  event | The Gdk::EventCrossing which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy0< void > Gtk::Widget::signal_map | ( |  | ) |

Emitted on mapping of a widget to the screen.

Slot Prototype:
  `void on_my_map()`

Glib::SignalProxy1< bool,GdkEventAny* > Gtk::Widget::signal_map_event | ( |  | ) |

Slot Prototype:
  `bool on_my_map_event(GdkEventAny* event)`

The signal_map_event() signal will be emitted when the widget's window is mapped. A window is mapped when it becomes visible on the screen.

To receive this signal, the Gdk::Window associated to the widget needs to enable the Gdk::STRUCTURE_MASK mask. GDK will enable this mask automatically for all new windows.

Parameters:

  event | The Gdk::EventAny which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy1< bool,bool > Gtk::Widget::signal_mnemonic_activate | ( |  | ) |

Slot Prototype:
  `bool on_my_mnemonic_activate(bool group_cycling)`

Glib::SignalProxy1< bool,GdkEventMotion* > Gtk::Widget::signal_motion_notify_event | ( |  | ) |

Event triggered by user moving pointer.

Slot Prototype:
  `bool on_my_motion_notify_event(GdkEventMotion* event)`

The signal_motion_notify_event() signal is emitted when the pointer moves over the widget's Gdk::Window.

To receive this signal, the Gdk::Window associated to the widget needs to enable the Gdk::POINTER_MOTION_MASK mask.

This signal will be sent to the grab widget if there is one.

Parameters:

  event | The Gdk::EventMotion which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy1< void,Widget* > Gtk::Widget::signal_parent_changed | ( |  | ) |

Informs objects that their parent changed.

Slot Prototype:
  `void on_my_parent_changed(Widget* previous_parent)`

The signal_parent_set() signal is emitted when a new parent has been set on a widget.

Parameters:

  old_parent | The previous parent, or `0` if the widget just got its initial parent.

Glib::SignalProxy0< bool > Gtk::Widget::signal_popup_menu | ( |  | ) |

Slot Prototype:
  `bool on_my_popup_menu()`

This signal gets emitted whenever a widget should pop up a context menu. This usually happens through the standard key binding mechanism; by pressing a certain key while a widget is focused, the user can cause the widget to pop up a menu. For example, the Gtk::Entry widget creates a menu with clipboard commands. See <xref linkend="checklist-popup-menu"> for an example of how to use this signal.

Returns:
  `true` if a menu was activated.

Glib::SignalProxy1< bool,GdkEventProperty* > Gtk::Widget::signal_property_notify_event | ( |  | ) |

Slot Prototype:
  `bool on_my_property_notify_event(GdkEventProperty* event)`

The signal_property_notify_event() signal will be emitted when a property on the widget's window has been changed or deleted.

To receive this signal, the Gdk::Window associated to the widget needs to enable the Gdk::PROPERTY_CHANGE_MASK mask.

Parameters:

  event | The Gdk::EventProperty which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy1< bool,GdkEventProximity* > Gtk::Widget::signal_proximity_in_event | ( |  | ) |

Slot Prototype:
  `bool on_my_proximity_in_event(GdkEventProximity* event)`

To receive this signal the Gdk::Window associated to the widget needs to enable the Gdk::PROXIMITY_IN_MASK mask.

This signal will be sent to the grab widget if there is one.

Parameters:

  event | The Gdk::EventProximity which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy1< bool,GdkEventProximity* > Gtk::Widget::signal_proximity_out_event | ( |  | ) |

Slot Prototype:
  `bool on_my_proximity_out_event(GdkEventProximity* event)`

To receive this signal the Gdk::Window associated to the widget needs to enable the Gdk::PROXIMITY_OUT_MASK mask.

This signal will be sent to the grab widget if there is one.

Parameters:

  event | The Gdk::EventProximity which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy4< bool,int,int,bool,const Glib::RefPtr<Tooltip>& > Gtk::Widget::signal_query_tooltip | ( |  | ) |

Slot Prototype:
  `bool on_my_query_tooltip(int x, int y, bool keyboard_tooltip, const Glib::RefPtr<Tooltip>& tooltip)`

Emitted when Gtk::Widget::property_has_tooltip() is `true` and the Gtk::Settings::property_gtk_tooltip_timeout() has expired with the cursor hovering "above" widget; or emitted when widget got focus in keyboard mode.

Using the given coordinates, the signal handler should determine whether a tooltip should be shown for widget. If this is the case `true` should be returned, `false` otherwise. Note that if keyboard_mode is `true`, the values of x and y are undefined and should not be used.

The signal handler is free to manipulate tooltip with the therefore destined function calls.

Since gtkmm 2.12:

Parameters:

  x | The x coordinate of the cursor position where the request has been emitted, relative to widget's left side.
  y | The y coordinate of the cursor position where the request has been emitted, relative to widget's top.
  keyboard_mode | `true` if the tooltip was trigged using the keyboard.
  tooltip | A Gtk::Tooltip.

Returns:
  `true` if tooltip should be shown right now, `false` otherwise.

Glib::SignalProxy0< void > Gtk::Widget::signal_realize | ( |  | ) |

Emitted on realization of a widget.

Slot Prototype:
  `void on_my_realize()`

Glib::SignalProxy1< void,const Glib::RefPtr<Gdk::Screen>& > Gtk::Widget::signal_screen_changed | ( |  | ) |

Slot Prototype:
  `void on_my_screen_changed(const Glib::RefPtr<Gdk::Screen>& previous_screen)`

The signal_screen_changed() signal gets emitted when the screen of a widget has changed.

Parameters:

  previous_screen | The previous screen, or `0` if the widget was not associated with a screen before.

Glib::SignalProxy1< bool,GdkEventScroll* > Gtk::Widget::signal_scroll_event | ( |  | ) |

Slot Prototype:
  `bool on_my_scroll_event(GdkEventScroll* event)`

The signal_scroll_event() signal is emitted when a button in the 4 to 7 range is pressed. Wheel mice are usually configured to generate button press events for buttons 4 and 5 when the wheel is turned.

To receive this signal, the Gdk::Window associated to the widget needs to enable the Gdk::BUTTON_PRESS_MASK mask.

This signal will be sent to the grab widget if there is one.

Parameters:

  event | The Gdk::EventScroll which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy1< bool,GdkEventSelection* > Gtk::Widget::signal_selection_clear_event | ( |  | ) |

Slot Prototype:
  `bool on_my_selection_clear_event(GdkEventSelection* event)`

The signal_selection_clear_event() signal will be emitted when the the widget's window has lost ownership of a selection.

Parameters:

  event | The Gdk::EventSelection which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy3< void,SelectionData&,guint,guint > Gtk::Widget::signal_selection_get | ( |  | ) |

Slot Prototype:
  `void on_my_selection_get(SelectionData& selection_data, guint info, guint time)`

Glib::SignalProxy1< bool,GdkEventSelection* > Gtk::Widget::signal_selection_notify_event | ( |  | ) |

Slot Prototype:
  `bool on_my_selection_notify_event(GdkEventSelection* event)`

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy2< void,const SelectionData&,guint > Gtk::Widget::signal_selection_received | ( |  | ) |

Slot Prototype:
  `void on_my_selection_received(const SelectionData& selection_data, guint time)`

Glib::SignalProxy1< bool,GdkEventSelection* > Gtk::Widget::signal_selection_request_event | ( |  | ) |

Slot Prototype:
  `bool on_my_selection_request_event(GdkEventSelection* event)`

The signal_selection_request_event() signal will be emitted when another client requests ownership of the selection owned by the widget's window.

Parameters:

  event | The Gdk::EventSelection which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy0< void > Gtk::Widget::signal_show | ( |  | ) |

Slot Prototype:
  `void on_my_show()`

Glib::SignalProxy1< void,Allocation& > Gtk::Widget::signal_size_allocate | ( |  | ) |

Slot Prototype:
  `void on_my_size_allocate(Allocation& allocation)`

Glib::SignalProxy1< void,Gtk::StateType > Gtk::Widget::signal_state_changed | ( |  | ) |

Slot Prototype:
  `void on_my_state_changed(Gtk::StateType previous_state)`

The signal_state_changed() signal is emitted when the widget state changes. See Gtk::Widget::get_state().

Deprecated: 3.0. Use Gtk::Widget::signal_state_flags_changed() instead.

Deprecated:
  Use signal_state_flags_changed() instead

Parameters:

  state | The previous state.

Glib::SignalProxy1< void,Gtk::StateFlags > Gtk::Widget::signal_state_flags_changed | ( |  | ) |

Slot Prototype:
  `void on_my_state_flags_changed(Gtk::StateFlags previous_state_flags)`

The signal_state_flags_changed() signal is emitted when the widget state changes, see Gtk::Widget::get_state_flags().

Since gtkmm 3.0:

Parameters:

  flags | The previous state flags.

Glib::SignalProxy0< void > Gtk::Widget::signal_style_updated | ( |  | ) |

Slot Prototype:
  `void on_my_style_updated()`

The signal_style_updated() signal is emitted when the Gtk::StyleContext of a widget is changed. Note that style-modifying functions like Gtk::Widget::override_color() also cause this signal to be emitted.

Since gtkmm 3.0:

Glib::SignalProxy1< bool,GdkEventTouch* > Gtk::Widget::signal_touch_event | ( |  | ) |

Slot Prototype:
  `bool on_my_touch_event(GdkEventTouch* event)`

Glib::SignalProxy0< void > Gtk::Widget::signal_unmap | ( |  | ) |

Slot Prototype:
  `void on_my_unmap()`

Glib::SignalProxy1< bool,GdkEventAny* > Gtk::Widget::signal_unmap_event | ( |  | ) |

Slot Prototype:
  `bool on_my_unmap_event(GdkEventAny* event)`

The signal_unmap_event() signal will be emitted when the widget's window is unmapped. A window is unmapped when it becomes invisible on the screen.

To receive this signal, the Gdk::Window associated to the widget needs to enable the Gdk::STRUCTURE_MASK mask. GDK will enable this mask automatically for all new windows.

Parameters:

  event | The Gdk::EventAny which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy0< void > Gtk::Widget::signal_unrealize | ( |  | ) |

Slot Prototype:
  `void on_my_unrealize()`

Glib::SignalProxy1< bool,GdkEventVisibility* > Gtk::Widget::signal_visibility_notify_event | ( |  | ) |

Slot Prototype:
  `bool on_my_visibility_notify_event(GdkEventVisibility* event)`

The signal_visibility_notify_event() will be emitted when the widget's window is obscured or unobscured.

To receive this signal the Gdk::Window associated to the widget needs to enable the Gdk::VISIBILITY_NOTIFY_MASK mask.

Parameters:

  event | The Gdk::EventVisibility which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy1< bool,GdkEventWindowState* > Gtk::Widget::signal_window_state_event | ( |  | ) |

Slot Prototype:
  `bool on_my_window_state_event(GdkEventWindowState* event)`

The signal_window_state_event() will be emitted when the state of the toplevel window associated to the widget changes.

To receive this signal the Gdk::Window associated to the widget needs to enable the Gdk::STRUCTURE_MASK mask. GDK will enable this mask automatically for all new windows.

Parameters:

  event | The Gdk::EventWindowState which triggered this signal.

Returns:
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

void Gtk::Widget::size_allocate | ( | const Allocation& | allocation | ) |

This function is only used by Gtk::Container subclasses, to assign a size and position to their child widgets.

In this function, the allocation may be adjusted. It will be forced to a 1x1 minimum size, and the adjust_size_allocation virtual method on the child will be used to adjust the allocation. Standard adjustments include removing the widget's margins, and applying the widget's Gtk::Widget::property_halign() and Gtk::Widget::property_valign() properties.

Parameters:

  allocation | Position and size to be allocated to widget.

void Gtk::Widget::thaw_child_notify | ( |  | ) |

Reverts the effect of a previous call to freeze_child_notify().

This causes all queued Gtk::Widget::signal_child_notify() signals on widget to be emitted.

void Gtk::Widget::transform_cairo_context_to_window | ( | const ::Cairo::RefPtr< ::Cairo::Context > & | cr,
|  | const Glib::RefPtr< const Gdk::Window >& | window
| ) |  | `[protected]`

Transforms the given cairo context cr from widget-relative coordinates to window-relative coordinates.

If the widget's window is not an ancestor of window, no modification will be applied.

This is the inverse to the transformation GTK applies when preparing an expose event to be emitted with the Widget's draw signal. It is intended to help porting multiwindow widgets from GTK+ 2 to the rendering architecture of GTK+ 3.

Parameters:

  cr | The cairo context to transform.
  window | The window to transform the context to.

Since gtkmm 3.0:

bool Gtk::Widget::translate_coordinates | ( | Widget& | dest_widget,
|  | int | src_x,
|  | int | src_y,
|  | int & | dest_x,
|  | int & | dest_y
| ) |  |

Translate coordinates relative to src_widget's allocation to coordinates relative to dest_widget's allocations.

In order to perform this operation, both widgets must be realized, and must share a common toplevel.

Parameters:

  dest_widget | A Gtk::Widget.
  src_x | X position relative to src_widget.
  src_y | Y position relative to src_widget.
  dest_x | Location to store X position relative to dest_widget.
  dest_y | Location to store Y position relative to dest_widget.

Returns:
  `false` if either widget was not realized, or there was no common ancestor. In this case, nothing is stored in * dest_x and * dest_y. Otherwise `true`.

void Gtk::Widget::trigger_tooltip_query | ( |  | ) |

Triggers a tooltip query on the display where the toplevel of widget is located.

See Gtk::Tooltip::trigger_tooltip_query() for more information.

Since gtkmm 2.12:

void Gtk::Widget::unmap | ( |  | ) |

This function is only for use in widget implementations.

Causes a widget to be unmapped if it's currently mapped.

void Gtk::Widget::unparent | ( |  | ) |

This function is only for use in widget implementations.

Should be called by implementations of the remove method on Gtk::Container, to dissociate a child from the container.

void Gtk::Widget::unrealize | ( |  | ) | `[protected]`

This function is only useful in widget implementations.

Causes a widget to be unrealized (frees all GDK resources associated with the widget, such as widget->window).

void Gtk::Widget::unset_background_color | ( | StateFlags | state = `(StateFlags) 0` | ) |

void Gtk::Widget::unset_color | ( | StateFlags | state = `(StateFlags) 0` | ) |

void Gtk::Widget::unset_composite_name | ( |  | ) |

void Gtk::Widget::unset_cursor | ( |  | ) |

void Gtk::Widget::unset_font | ( |  | ) |

void Gtk::Widget::unset_name | ( |  | ) |

void Gtk::Widget::unset_state_flags | ( | StateFlags | flags | ) |

This function is for use in widget implementations.

Turns off flag values for the current widget state (insensitive, prelighted, etc.). See set_state_flags().

Since gtkmm 3.0:

Parameters:

  flags | State flags to turn off.

void Gtk::Widget::unset_symbolic_color | ( | const Glib::ustring & | name | ) |

## Friends And Related Function Documentation

Gtk::Widget* wrap | ( | GtkWidget * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/widget.h